package Info;

my $pkg="Info";

use strict;
use My;

#== Napojeni na databazi
my $dbh=My->dbh;

#- vraci v hashi informace o zak
sub zak {
   my ($pkg_p, $zak, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Zakazky.*
      from
         Zakazky.Zakazky
      where
         Zakazky.zak=?
   };
   push(@dotazpara,($zak));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Zakazky.platod>?
         order by
            Zakazky.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Zakazky.platod<=? and
            Zakazky.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{zak}=$zak;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z nakupniho ceniku zak
sub zak_cenik {
   my ($pkg_p, $zak, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Zakazky_cenik.*
      from
         Zakazky.Zakazky_cenik
      where
         Zakazky_cenik.zak=?
   };
   push(@dotazpara,($zak));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Zakazky_cenik.platod>?
         order by
            Zakazky_cenik.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Zakazky_cenik.platod<=? and
            Zakazky_cenik.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{zak}=$zak;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o mat
sub mat {
   my ($pkg_p, $mat, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Material.*
      from
         Material.Material
      where
         Material.mat=?
   };
   push(@dotazpara,($mat));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Material.platod>?
         order by
            Material.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Material.platod<=? and
            Material.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{mat}=$mat;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o mat z ceniku
sub mat_cenik {
   my ($pkg_p, $mat, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Material_cenik.*
      from
         Material.Material_cenik
      where
         Material_cenik.mat=?
   };
   push(@dotazpara,($mat));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Material_cenik.platod>?
         order by
            Material_cenik.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Material_cenik.platod<=? and
            Material_cenik.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{mat}=$mat;
   $$ref{faktcena}=$$ref{cena}*(1+$$ref{prir}/100);
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o mat z ceniku - vraci "pevnou cenu" - za pevnou cenu je povazovana prvni platna cena v aktualnim roce
sub mat_cenik_pevna {
   my ($pkg_p, $mat)=@_;
   # vrati cenu ktera platila 1.ledna prisl roku a pokud takova neni, vrati prvni platnou cenu v danem roce
   my $sth=$dbh->prepare(q{
      select
         Material_cenik.*
      from
         Material.Material_cenik
      where
         Material_cenik.mat=? and
         (
            (Material_cenik.platod<=? and Material_cenik.platdo>=?) or
            substring(Material_cenik.platod,1,4)=?
         )
      order by
         Material_cenik.platod asc
      limit
         1
   });
   my $rok=substr(get_env("datum"),0,4);
   $sth->execute($mat,$rok."-01-01",$rok."-01-01",$rok);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{faktcena}=$$ref{cena}*(1+$$ref{prir}/100);
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o nar
sub nar {
   my ($pkg_p, $nar, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Naradi.*
      from
         Naradi.Naradi
      where
         Naradi.nar=?
   };
   push(@dotazpara,($nar));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Naradi.platod>?
         order by
            Naradi.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Naradi.platod<=? and
            Naradi.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{nar}=$nar;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o nar technologa
sub nartech {
   my ($pkg_p, $nar, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Naraditech.*
      from
         Naradi.Naraditech
      where
         Naraditech.nar=?
   };
   push(@dotazpara,($nar));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Naraditech.platod>?
         order by
            Naraditech.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Naraditech.platod<=? and
            Naraditech.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{nar}=$nar;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o organizaci
sub org {
   my ($pkg_p, $org)=@_;
   if(!defined($org)) {
      $org=get_env("org");
   }
   my $sth=$dbh->prepare(q{
      select
         Org.*
      from
         Spolecnost.Org
      where
         Org.org=?
   });
   $sth->execute($org);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o organizaci spolecnosti
sub sorg {
   my ($pkg_p, $sorg)=@_;
   if(!defined($sorg)) {
      my $info_org=$pkg->org;
      $sorg=$$info_org{sorg};
   }
   my $sth=$dbh->prepare(q{
      select
         Sorg.*
      from
         Spolecnost.Sorg
      where
         Sorg.sorg=?
   });
   $sth->execute($sorg);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o stredisku
sub str {
   my ($pkg_p, $str, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Str.*
      from
         Spolecnost.Str
      where
         Str.str=?
   };
   push(@dotazpara,($str));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Str.platod>?
         order by
            Str.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Str.platod<=? and
            Str.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{str}=$str;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z ciselniku typu strediska
sub vyrtyp {
   my ($pkg_p, $vyrtyp)=@_;
   my $sth=$dbh->prepare(q{
      select
         Vyrtyp.*
      from
         Spolecnost.Vyrtyp
      where
         Vyrtyp.vyrtyp=?
   });
   $sth->execute($vyrtyp);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{vyrtyp}=$vyrtyp;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o zamestnanci, jen z tabulky Zamestnanci
sub zamestnanci {
   my ($pkg_p, $oc, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Zamestnanci.*
      from
         Zamestnanci.Zamestnanci
      where
         Zamestnanci.oc=?
   };
   push(@dotazpara,($oc));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Zamestnanci.platod>?
         order by
            Zamestnanci.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Zamestnanci.platod<=? and
            Zamestnanci.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{oc}=$oc;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o zamestnanci, jen z tabulky Zamestnanci_zamestnani
sub zamestnanci_zamestnani {
   my ($pkg_p, $oc, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Zamestnanci_zamestnani.*
      from
         Zamestnanci.Zamestnanci_zamestnani
      where
         Zamestnanci_zamestnani.oc=?
   };
   push(@dotazpara,($oc));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Zamestnanci_zamestnani.platod>?
         order by
            Zamestnanci_zamestnani.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Zamestnanci_zamestnani.platod<=? and
            Zamestnanci_zamestnani.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{oc}=$oc;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o zamestnanci, jen z tabulky Zamestnanci_funkce
sub zamestnanci_funkce {
   my ($pkg_p, $oc, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Zamestnanci_funkce.*
      from
         Zamestnanci.Zamestnanci_funkce
      where
         Zamestnanci_funkce.oc=?
   };
   push(@dotazpara,($oc));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Zamestnanci_funkce.platod>?
         order by
            Zamestnanci_funkce.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Zamestnanci_funkce.platod<=? and
            Zamestnanci_funkce.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{oc}=$oc;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o oc - !!! jde zde o nekolik dotazu => celkem pomale - ovsem muzes si rici, ktere udaje opravdu potrebujes...
# pointer na hash v kolonce udaje rika co vse chci jeste vedet navic oproti zakladnim udajum
#    mozne hodnoty:  zamfce, uziv, tel, ock
#    Priklad pouziti: my $info_oc=Info->oc($$ref{oc},{uziv=>1,zamfce=>1,tel=>1,ock=>1});
sub oc {
   my ($pkg_p, $oc,$udaje)=@_;
   my $ref;
   # zamestnanci
   if($oc!~/^K/) {
      # zjisteni zakladnich udaju zamestnance jako je jmeno, rodc, ...
      $ref=$pkg->zamestnanci($oc);
      # zjisteni typu zamestnance (JRD,..) a zjisteni jeho strediska
      my $ref_zam=$pkg->zamestnanci_zamestnani($oc);
      foreach my $key ("str","tt","tydenuvazek","typzam","stavzam","stavzampozn") {
         $$ref{$key}=$$ref_zam{$key};
      }
      #- Udaje navic - musis si o ne rici!!!
      # zamfce
      if($$udaje{zamfce}) {
         my $ref_zamfce=$pkg->zamestnanci_funkce($oc);
         foreach my $key ("funkce_nazev") {
            $$ref{$key}=$$ref_zamfce{$key};
         }
      }
      # uziv
      if($$udaje{uziv}) {
         my $sth_uziv=$dbh->prepare(q{
            select
               Uzivatele.uziv,
               concat(Uzivatele.uziv,'@',?) as mail
            from
               Zamestnanci.Uzivatele
            where
               Uzivatele.oc=?
         });
         $sth_uziv->execute(My->domain,$oc);
         my $ref_uziv=$sth_uziv->fetchrow_hashref;
         $sth_uziv->finish;
         foreach my $key ("uziv","mail") {
            $$ref{$key}=$$ref_uziv{$key};
         }
      }
      # tel
      if($$udaje{tel}) {
         my $sth_tel=$dbh->prepare(q{
            select
               Telefony_uzivatel.tel
            from
               Komunikace.Telefony_uzivatel
            where
               Telefony_uzivatel.uzivatel=? and
               Telefony_uzivatel.uzivatel_druh=?
         });
         $sth_tel->execute($oc,"oc");
         my %tel;
         while(my $ref_tel=$sth_tel->fetchrow_hashref) {
            $tel{"tel"}.=$$ref_tel{"tel"}.", ";
         }
         $sth_tel->finish;
         chop($tel{"tel"}); chop($tel{"tel"});
         $$ref{tel}=$tel{"tel"};
      }
      # ock - osobni cislo kolektivu, do ktereho uzivatel patri
      if($$udaje{ock}) {
         my $sth_ock=$dbh->prepare(q{
            select
               Zamestnanci_kolektivy.ock
            from
               Zamestnanci.Zamestnanci_kolektivy
            where
               Zamestnanci_kolektivy.oc=? and
               Zamestnanci_kolektivy.platod<=? and
               Zamestnanci_kolektivy.platdo>=?
         });
         $sth_ock->execute($oc,get_env("datum"),get_env("datum"));
         my $ref_ock=$sth_ock->fetchrow_hashref;
         $sth_ock->finish;
         foreach my $key ("ock") {
            $$ref{$key}=$$ref_ock{$key};
         }
      }
   }
   # kolektivy
   else {
      my $sth=$dbh->prepare(q{
         select
            Kolektivy.*,
            Kolektivy.nazev as prijmeni
         from
            Spolecnost.Kolektivy
         where
            Kolektivy.oc=? and
            Kolektivy.platod<=? and
            Kolektivy.platdo>=?
      });
      $sth->execute($oc,get_env("datum"),get_env("datum"));
      $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
   }
   # zjisteni informaci o org zamestnance ci kolektivu
   my $info_str=$pkg->str($$ref{str});
   $$ref{org}=$$info_str{org};
   $$ref{str_nazev}=$$info_str{nazev};
   return $ref;
}

#- vraci v hashi informace o uzivateli - parametry viz fce "oc" vyse
#    Priklad pouziti: my $info_uziv=Info->uziv($uziv,{uziv=>1,zamfce=>1,tel=>1});
sub uziv {
   my ($pkg_p, $uziv,$udaje)=@_;
   my $sth=$dbh->prepare(q{
      select
         Uzivatele.oc
      from
         Zamestnanci.Uzivatele
      where
         Uzivatele.uziv=?
   });
   $sth->execute($uziv);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   my $ref_oc=$pkg->oc($$ref{oc},$udaje);
   $$ref_oc{uziv}=$uziv;
   $$ref_oc{_exist}=$sth->rows;
   return $ref_oc;
}

#- vraci v hashi informace z ciselniku stavu zamestnani
sub stavzam {
   my ($pkg_p, $stavzam)=@_;
   my $sth=$dbh->prepare(q{
      select
         Stavzam.*
      from
         Zamestnanci.Stavzam
      where
         Stavzam.stavzam=?
   });
   $sth->execute($stavzam);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{stavzam}=$stavzam;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z ciselniku typu zamestnani
sub typzam {
   my ($pkg_p, $typzam)=@_;
   my $sth=$dbh->prepare(q{
      select
         Typzam.*
      from
         Zamestnanci.Typzam
      where
         Typzam.typzam=?
   });
   $sth->execute($typzam);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{typzam}=$typzam;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o aktualnim okruhu (respektive zadanem)
sub okruh {
   my ($pkg_p, $okruh)=@_;
   my $ref=My->okruh_info($okruh);
   return $ref;
}

#- vraci v hashi informace o pracovisti
sub prac {
   my ($pkg_p, $str,$prac, $opt)=@_;
   my $info_prac;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Pracoviste.*
      from
         Vyroba_priprava.Pracoviste
      where
         Pracoviste.str=?
   };
   push(@dotazpara,($str));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Pracoviste.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Pracoviste.platod<=? and
            Pracoviste.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($prac)) {
      $dotaz.=q{
            and Pracoviste.prac=?
      };
      push(@dotazpara,($prac));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Pracoviste.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_prac=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Pracoviste.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_prac{$$ref{prac}}=$ref;
      }
      $sth->finish;
   }
   return $info_prac;
}

#- vraci v hashi informace o skupine pracovist
sub skupprac {
   my ($pkg_p,$str,$skupprac)=@_;
   my $sth=$dbh->prepare(q{
      select
         Pracoviste.str,
         Pracoviste.skup as skupprac,
         sum(Pracoviste.pocet) as pocet
      from
         Vyroba_priprava.Pracoviste
      where
         Pracoviste.str=? and
         Pracoviste.skup=? and
         Pracoviste.platod<=? and
         Pracoviste.platdo>=?
      group by
         Pracoviste.str,
         skupprac
   });
   $sth->execute($str,$skupprac,get_env("datum"),get_env("datum"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{str}=$str;
   $$ref{skupprac}=$skupprac;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o skladu
sub sklad {
   my ($pkg_p, $sklad, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Sklady.*
      from
         Spolecnost.Sklady
      where
         Sklady.sklad=?
   };
   push(@dotazpara,($sklad));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Sklady.platod>?
         order by
            Sklady.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Sklady.platod<=? and
            Sklady.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{sklad}=$sklad;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o charakteristice
sub ch {
   my ($pkg_p,$ch)=@_;
   my $sth=$dbh->prepare(q{
      select
         Charakteristiky.*
      from
         Zakazky.Charakteristiky
      where
         Charakteristiky.ch=?
   });
   $sth->execute($ch);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o uctu z ucetni osnovy
sub ucet {
   my ($pkg_p,$ucet)=@_;
   my $sth=$dbh->prepare(q{
      select
         UcetOsnova.*
      from
         Ucetnictvi.UcetOsnova
      where
         UcetOsnova.ucet=? and
         UcetOsnova.platod<=? and
         UcetOsnova.platdo>=?
   });
   $sth->execute($ucet,get_env("datum"),get_env("datum"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{ucet}=$ucet;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi radek normativu - umi vratit i predchozi ci nasledujici, nez je zadano
# krok je 0 nebo undef => vratim radek normativu se zadanym kmint
# krok je -1 => predchozi radek normativu, nez je zadany kmint
# krok je 1 => nasledujici radek normativu, nez je zadany kmint
sub normativy {
   my ($pkg_p, $zak,$kmint, $krok)=@_;
   my $sth;
   if(!$krok) {
      $sth=$dbh->prepare(q{
         select
            Normativy.*
         from
            Vyroba_planovani.Normativy
         where
            Normativy.zak=? and
            Normativy.kmint=? and
            Normativy.platod<=? and
            Normativy.platdo>=?
      });
   }
   elsif($krok<0) {
      $sth=$dbh->prepare(q{
         select
            Normativy.*
         from
            Vyroba_planovani.Normativy
         where
            Normativy.zak=? and
            Normativy.kmint<? and
            Normativy.platod<=? and
            Normativy.platdo>=?
         order by
            Normativy.kmint desc
         limit
            1
      });
   }
   else {
      $sth=$dbh->prepare(q{
         select
            Normativy.*
         from
            Vyroba_planovani.Normativy
         where
            Normativy.zak=? and
            Normativy.kmint>? and
            Normativy.platod<=? and
            Normativy.platdo>=?
         order by
            Normativy.kmint asc
         limit
            1
      });
   }
   $sth->execute($zak,$kmint,get_env("datum"),get_env("datum"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi radek normativu, dle zadaneho cisla operace
sub normativyoper {
   my ($pkg_p, $zak,$oper)=@_;
   my $sth=$dbh->prepare(q{
      select
         Normativy.*
      from
         Vyroba_planovani.Normativy
      where
         Normativy.zak=? and
         Normativy.odoper<=? and
         Normativy.dooper>=? and
         Normativy.platod<=? and
         Normativy.platdo>=?
   });
   $sth->execute($zak,$oper,$oper,get_env("datum"),get_env("datum"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi radek Vyrprikazy
sub vyrprikazy {
   my ($pkg_p, $zak,$kmint,$prik)=@_;
   my $sth=$dbh->prepare(q{
      select
         Vyrprikazy.*
      from
         Vyroba_planovani.Vyrprikazy
      where
         Vyrprikazy.org=? and
         Vyrprikazy.zak=? and
         Vyrprikazy.kmint=? and
         Vyrprikazy.prik=?
   });
   $sth->execute(get_env("org"),$zak,$kmint,$prik);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi radky Kusovnik
sub kusovnik {
   my ($pkg_p, $zak,$zakn, $opt)=@_;
   my $info_kus;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Kusovnik.*
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakv=?
   };
   push(@dotazpara,($zak));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Kusovnik.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Kusovnik.platod<=? and
            Kusovnik.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($zakn)) {
      $dotaz.=q{
            and Kusovnik.zakn=?
      };
      push(@dotazpara,($zakn));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Kusovnik.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_kus=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Kusovnik.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_kus{$$ref{zakn}}=$ref;
      }
      $sth->finish;
   }
   return $info_kus;
}

#- vraci v hashi radek Vykon_norma
sub vykon_norma {
   my ($pkg_p, $zak,$oper, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Vykon_norma.*
      from
         Vyroba_priprava.Vykon_norma
      where
         Vykon_norma.zak=? and
         Vykon_norma.oper=?
   };
   push(@dotazpara,($zak,$oper));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Vykon_norma.platod>?
         order by
            Vykon_norma.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Vykon_norma.platod<=? and
            Vykon_norma.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   if($$ref{_exist}) {
      $$ref{takc}=$pkg->tkc($$ref{tta},$$ref{tamin});
      $$ref{tbkc}=$pkg->tkc($$ref{ttb},$$ref{tbmin});
   }
   return $ref;
}

#- funkce vraci tkc
sub tkc {
   my ($pkg_p, $tt,$tmin)=@_;
   my $info_sazebnik=$pkg->sazebnik($tt);
   my $tkc=$tmin*$$info_sazebnik{sazba}/60;
   return $tkc;
}

#- vraci v hashi radky Material_norma
sub material_norma {
   my ($pkg_p, $zak,$oper,$mat, $opt)=@_;
   my $info_mn;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Material_norma.*
      from
         Vyroba_priprava.Material_norma
      where
         Material_norma.zak=? and
         Material_norma.oper=?
   };
   push(@dotazpara,($zak,$oper));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Material_norma.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Material_norma.platod<=? and
            Material_norma.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($mat)) {
      $dotaz.=q{
            and Material_norma.mat=?
      };
      push(@dotazpara,($mat));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Material_norma.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_mn=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Material_norma.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_mn{$$ref{mat}}=$ref;
      }
      $sth->finish;
   }
   return $info_mn;
}

#- vraci v hashi radky Naradi_norma
sub naradi_norma {
   my ($pkg_p, $zak,$oper,$nar, $opt)=@_;
   my $info_nn;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Naradi_norma.*
      from
         Vyroba_priprava.Naradi_norma
      where
         Naradi_norma.zak=? and
         Naradi_norma.oper=?
   };
   push(@dotazpara,($zak,$oper));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Naradi_norma.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Naradi_norma.platod<=? and
            Naradi_norma.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($nar)) {
      $dotaz.=q{
            and Naradi_norma.nar=?
      };
      push(@dotazpara,($nar));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Naradi_norma.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_nn=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Naradi_norma.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_nn{$$ref{nar}}=$ref;
      }
      $sth->finish;
   }
   return $info_nn;
}

#- vraci v hashi radky Naraditech_norma
sub naraditech_norma {
   my ($pkg_p, $zak,$oper,$nar, $opt)=@_;
   my $info_nn;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Naraditech_norma.*
      from
         Vyroba_priprava.Naraditech_norma
      where
         Naraditech_norma.zak=? and
         Naraditech_norma.oper=?
   };
   push(@dotazpara,($zak,$oper));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Naraditech_norma.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Naraditech_norma.platod<=? and
            Naraditech_norma.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($nar)) {
      $dotaz.=q{
            and Naraditech_norma.nar=?
      };
      push(@dotazpara,($nar));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Naraditech_norma.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_nn=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Naraditech_norma.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_nn{$$ref{nar}}=$ref;
      }
      $sth->finish;
   }
   return $info_nn;
}

#- vraci v hashi radek Popis_operace
sub popis_operace {
   my ($pkg_p, $zak,$oper, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Popis_operace.*
      from
         Vyroba_priprava.Popis_operace
      where
         Popis_operace.zak=? and
         Popis_operace.oper=?
   };
   push(@dotazpara,($zak,$oper));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Popis_operace.platod>?
         order by
            Popis_operace.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Popis_operace.platod<=? and
            Popis_operace.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi radek Prilohy_operace
sub prilohy_operace {
   my ($pkg_p, $zak,$oper,$druh,$ozn, $opt)=@_;
   my $info_pro;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Prilohy_operace.*
      from
         Vyroba_priprava.Prilohy_operace
      where
         Prilohy_operace.zak=? and
         Prilohy_operace.oper=? and
         Prilohy_operace.druh=?
   };
   push(@dotazpara,($zak,$oper,$druh));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Prilohy_operace.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Prilohy_operace.platod<=? and
            Prilohy_operace.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($ozn)) {
      $dotaz.=q{
            and Prilohy_operace.ozn=?
      };
      push(@dotazpara,($ozn));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Prilohy_operace.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_pro=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Prilohy_operace.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_pro{$$ref{ozn}}=$ref;
      }
      $sth->finish;
   }
   return $info_pro;
}

#- vraci v informaci o druhu prilohy
sub prilohy_operace_druh {
   my ($pkg_p, $druh)=@_;
   my $sth=$dbh->prepare(q{
      select
         Prilohy_operace_druhy.*
      from
         Vyroba_priprava.Prilohy_operace_druhy
      where
         Prilohy_operace_druhy.druh=?
   });
   $sth->execute($druh);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci hash, obsahujici v klici vsechny mozne operace pouzitelne ve vyrobnim postupu
sub vyrobni_postup_oper {
   my ($pkg_p, $zak)=@_;
   my $operl;
   my $org;
   if(get_env("org") ne "0") {
      $org=get_env("org");
   }
   else {
      my $info_zak=Info->zak($zak);
      $org=$$info_zak{kmorg};
   }
   my $sth=$dbh->prepare(q{
      select distinct
         Material_norma.oper
      from
         Vyroba_priprava.Material_norma
      where
         Material_norma.zak=? and
         Material_norma.platod<=? and
         Material_norma.platdo>=? and
         Material_norma.oper!="999"
   });
   $sth->execute($zak,get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      $$operl{$$ref{oper}}=1;
   }
   $sth->finish;
   my $sth=$dbh->prepare(q{
      select distinct
         Naradi_norma.oper
      from
         Vyroba_priprava.Naradi_norma
      where
         Naradi_norma.zak=? and
         Naradi_norma.platod<=? and
         Naradi_norma.platdo>=? and
         Naradi_norma.oper!="999"
   });
   $sth->execute($zak,get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      $$operl{$$ref{oper}}=1;
   }
   $sth->finish;
   my $sth=$dbh->prepare(q{
      select distinct
         Vykon_norma.oper
      from
         Vyroba_priprava.Vykon_norma
      where
         Vykon_norma.zak=? and
         Vykon_norma.platod<=? and
         Vykon_norma.platdo>=? and
         Vykon_norma.oper!="999"
   });
   $sth->execute($zak,get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      $$operl{$$ref{oper}}=1;
   }
   $sth->finish;
   my $sth=$dbh->prepare(q{
      select distinct
         Popis_operace.oper
      from
         Vyroba_priprava.Popis_operace
      where
         Popis_operace.zak=? and
         Popis_operace.platod<=? and
         Popis_operace.platdo>=? and
         Popis_operace.oper!="999"
   });
   $sth->execute($zak,get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      $$operl{$$ref{oper}}=1;
   }
   $sth->finish;
   my $sth=$dbh->prepare(q{
      select distinct
         Prilohy_operace.oper
      from
         Vyroba_priprava.Prilohy_operace
      where
         Prilohy_operace.zak=? and
         Prilohy_operace.platod<=? and
         Prilohy_operace.platdo>=? and
         Prilohy_operace.oper!="999"
   });
   $sth->execute($zak,get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      $$operl{$$ref{oper}}=1;
   }
   $sth->finish;
   return $operl;
}

#- vraci v hashi informace o schvaleni vyrobniho postupu
sub zak_schval {
   my ($pkg_p, $zak)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Zakazky_schval.*
      from
         Zakazky.Zakazky_schval
      where
         Zakazky_schval.zak=?
   };
   push(@dotazpara,($zak));
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{zak}=$zak;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o cene z postupnych souctu (Vnitr_ceny)
sub vnitr_ceny {
   my ($pkg_p,$zak,$oper)=@_;
   my $sth;
   if($oper eq "*") {
      $sth=$dbh->prepare(q{
         select
            Vnitr_ceny.*
         from
            Vyroba_ceny.Vnitr_ceny
         where
            Vnitr_ceny.org=? and
            Vnitr_ceny.rok=? and
            Vnitr_ceny.zak=? and
            Vnitr_ceny.posloper=?
         order by
            Vnitr_ceny.znupl desc
         limit
            1
      });
   }
   else {
      $sth=$dbh->prepare(q{
         select
            Vnitr_ceny.*
         from
            Vyroba_ceny.Vnitr_ceny
         where
            Vnitr_ceny.org=? and
            Vnitr_ceny.rok=? and
            Vnitr_ceny.zak=? and
            Vnitr_ceny.oper<=?
         order by
            Vnitr_ceny.oper desc
         limit
            1
      });
   }
   $sth->execute(get_env("org"),substr(get_env("datum"),0,4),$zak,$oper);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{uvn}=$$ref{mat}+$$ref{koop}+$$ref{mzda}+$$ref{opn1}+$$ref{opn2}+$$ref{vyrrez}+$$ref{sprrez};
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o cene z ceniku kooperaci
sub kooperace_cenik {
   my ($pkg_p, $zak, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Kooperace_cenik.*
      from
         Vyroba_priprava.Kooperace_cenik
      where
         Kooperace_cenik.zak=?
   };
   push(@dotazpara,($zak));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Kooperace_cenik.platod>?
         order by
            Kooperace_cenik.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Kooperace_cenik.platod<=? and
            Kooperace_cenik.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{zak}=$zak;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z Vyroba_stav
sub vyroba_stav {
   my ($pkg_p, $zak,$kmint,$str)=@_;
   my $sth=$dbh->prepare(q{
      select
         Vyroba_stav.*
      from
         Vyroba_evidence.Vyroba_stav
      where
         Vyroba_stav.org=? and
         Vyroba_stav.zak=? and
         Vyroba_stav.kmint=? and
         Vyroba_stav.str=?
   });
   $sth->execute(get_env("org"),$zak,$kmint,$str);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{stav}=$$ref{ksvych}+$$ref{ksprij}-$$ref{kszm}-$$ref{ksodv};
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z Stavmat
sub stavmat {
   my ($pkg_p, $sklad,$mat)=@_;
   my $org;
   if(get_env("org") ne "0") {
      $org=get_env("org");
   }
   else {
      my $info_sklad=$pkg->sklad($sklad);
      my $str=$$info_sklad{supstr};
      my $info_str=$pkg->str($str);
      $org=$$info_str{org};
   }
   my $sth=$dbh->prepare(q{
      select
         Stavmat.*
      from
         Material.Stavmat
      where
         Stavmat.org=? and
         Stavmat.sklad=? and
         Stavmat.mat=?
   });
   $sth->execute($org,$sklad,$mat);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z StavHV
sub stavhv {
   my ($pkg_p, $zak,$var,$str)=@_;
   my $sth=$dbh->prepare(q{
      select
         StavHV.*
      from
         Vyroba_evidence.StavHV
      where
         StavHV.org=? and
         StavHV.zak=? and
         StavHV.var=? and
         StavHV.str=?
   });
   $sth->execute(get_env("org"),$zak,$var,$str);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z Adresare
sub adresar {
   my ($pkg_p, $ico,$cadr)=@_;
   if(!defined($cadr)) {
      $cadr="000";
   }
   my $sth=$dbh->prepare(q{
      select
         Adresarcadr.*,
         Adresar.zakaznik,
         Adresar.dico,
         Adresar.pozn
      from
         Spolecnost.Adresar
         inner join Spolecnost.Adresarcadr on (Adresar.ico=Adresarcadr.ico)
      where
         Adresar.ico=? and
         Adresarcadr.cadr=?
   });
   $sth->execute($ico,$cadr);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{ico}=$ico;
   $$ref{cadr}=$cadr;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace z Adresarcadr - jiz na odstrel - fci plen prebrala fce adresar
sub adresarcadr {
   my ($pkg_p, $ico,$cadr)=@_;
   my $ref=$pkg->adresar($ico,$cadr);
   return $ref;
}

#- vraci v seznam adres z Adresarcadr k danemu ico
sub adresarcadrlist {
   my ($pkg_p, $ico)=@_;
   my $sth=$dbh->prepare(q{
      select
         Adresarcadr.cadr
      from
         Spolecnost.Adresarcadr
      where
         Adresarcadr.ico=?
      order by
         Adresarcadr.cadr asc
   });
   $sth->execute($ico);
   my @cadrlist;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@cadrlist,$$ref{cadr});
   }
   $sth->finish;
   return @cadrlist;
}

#- vraci v hashi informace z Adresare del zakaznik
sub adresarzak {
   my ($pkg_p, $zakaznik,$cadr)=@_;
   my $sth=$dbh->prepare(q{
      select
         Adresar.ico
      from
         Spolecnost.Adresar
      where
         Adresar.zakaznik=?
   });
   $sth->execute($zakaznik);
   my $refzak=$sth->fetchrow_hashref;
   $sth->finish;
   my $ref=$pkg->adresar($$refzak{ico},$cadr);
   return $ref;
}

#- vraci v hashi informace z Adresare
sub partner {
   my ($pkg_p, $partner,$cadr)=@_;
   my $ref=$pkg->adresar($partner,$cadr);
   if(!$$ref{_exist}) {
      $ref=$pkg->adresarzak($partner,$cadr);
   }
   return $ref;
}

#- zjisteni sazby za minutu u prislusne tridy
sub sazebnik {
   my ($pkg_p, $tt, $opt)=@_;
   my $info_saz;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Sazebnik.*
      from
         Spolecnost.Sazebnik
      where
         1
   };
   if($$opt{future}) {
      $dotaz.=q{
            and
            Sazebnik.platod>?
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Sazebnik.platod<=? and
            Sazebnik.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   if(defined($tt)) {
      $dotaz.=q{
            and Sazebnik.tt=?
      };
      push(@dotazpara,($tt));
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Sazebnik.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$ref{_exist}=$sth->rows;
      $info_saz=$ref;
   }
   else {
      if($$opt{future}) {
         $dotaz.=q{
            order by
               Sazebnik.platod asc
            limit
               1
         };
      }
      my $sth=$dbh->prepare($dotaz);
      $sth->execute(@dotazpara);
      while(my $ref=$sth->fetchrow_hashref) {
         $$info_saz{$$ref{tt}}=$ref;
      }
      $sth->finish;
   }
   return $info_saz;
}

#- vraci v hashi znaky uplnosti s nazvy, ktere shrnuje zadany znupl
sub znupl {
   my ($pkg_p, $znupl)=@_;
   my $refznupl;
   my $sth=$dbh->prepare(q{
      select
         Znupl.znupl,
         Znupl.nazev
      from
         Vyroba_ceny.Znupl
      where
         Znupl.bit=?
   });
   my $i=0;
   if($znupl ne "0") {
      foreach my $is (reverse split(//,sprintf("%b",$znupl))) {
         ++$i;
         if($is) {
            $sth->execute($i);
            my $ref=$sth->fetchrow_hashref;
            $sth->finish;
            $$refznupl{$$ref{znupl}}=$$ref{nazev};
         }
      }
   }
   else {
      $sth->execute($i);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      $$refznupl{$$ref{znupl}}=$$ref{nazev};
   }
   return $refznupl;
}

#- vraci v hashi rezie pro dane stredisko
sub rezie {
   my ($pkg_p, $str, $opt)=@_;
   my ($dotaz,@dotazpara);
   $dotaz.=q{
      select
         Rezie.*
      from
         Spolecnost.Rezie
      where
         Rezie.str=?
   };
   push(@dotazpara,($str));
   if($$opt{future}) {
      $dotaz.=q{
            and
            Rezie.platod>?
         order by
            Rezie.platod asc
         limit
            1
      };
      push(@dotazpara,(get_env("datum")));
   }
   else {
      $dotaz.=q{
            and
            Rezie.platod<=? and
            Rezie.platdo>=?
      };
      push(@dotazpara,(get_env("datum"),get_env("datum")));
   }
   my $sth=$dbh->prepare($dotaz);
   $sth->execute(@dotazpara);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{str}=$str;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o kapacitnich koeficientech pracoviste
sub kapprac {
   my ($pkg_p,$str,$prac)=@_;
   my $sth=$dbh->prepare(q{
      select
         Kapkoef.*
      from
         Vyroba_kapacity.Kapkoef
      where
         Kapkoef.str=? and
         Kapkoef.prac=? and
         Kapkoef.platod<=? and
         Kapkoef.platdo>=?
   });
   $sth->execute($str,$prac,get_env("datum"),get_env("datum"));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   if($sth->rows<1) {
      $sth->execute($str,"",get_env("datum"),get_env("datum"));
      $ref=$sth->fetchrow_hashref;
      $sth->finish;
   }
   $$ref{str}=$str;
   $$ref{prac}=$prac;
   $$ref{_exist}=$sth->rows;
   if(!$$ref{_exist}) {
      $$ref{ztraty}=1;
      $$ref{vykon}=1;
      $$ref{smeny}=1;
      $$ref{strojobsl}=1;
   }
   return $ref;
}

#- vraci v hashi informace o fondu pracovni doby pro ucely kapacitnich propoctu
sub kapfond {
   my ($pkg_p,$org,$druhobd)=@_;
   my $kapfond;
   if(!defined($org)) {
      $org=get_env("org");
   }
   if(!defined($druhobd)) {
      $druhobd="m";
   }
   my $sth=$dbh->prepare(q{
      select
         Kapfond.*
      from
         Vyroba_kapacity.Kapfond
      where
         Kapfond.org=? and
         Kapfond.rok=?
   });
   $sth->execute($org,substr(get_env("datum"),0,4));
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   my $m=substr(get_env("datum"),5,2);
   if($druhobd eq "m") {
      $kapfond=$$ref{"m".$m};
   }
   elsif($druhobd eq "q") {
      my $mN=1*$m;
      if($mN<=3) {
         $kapfond=$$ref{"m01"}+$$ref{"m02"}+$$ref{"m03"};
      }
      elsif($mN<=6) {
         $kapfond=$$ref{"m04"}+$$ref{"m05"}+$$ref{"m06"};
      }
      elsif($mN<=9) {
         $kapfond=$$ref{"m07"}+$$ref{"m08"}+$$ref{"m09"};
      }
      else {
         $kapfond=$$ref{"m10"}+$$ref{"m11"}+$$ref{"m12"};
      }
   }
   elsif($druhobd eq "d") {
      $kapfond=$$ref{"m".$m}/3;
   }
   #if(!$kapfond) {
   #   die "Schazi udaje o fondu pracovni doby! (" . "org: " . $org . ", druhobd: " . $druhobd . ", datum: " . get_env("datum") . ")";
   #}
   return $kapfond;
}

#- vraci v hashi informace o merne jednotce
sub mj {
   my ($pkg_p, $mj)=@_;
   my $sth=$dbh->prepare(q{
      select
         Mj.*
      from
         Zakazky.Mj
      where
         Mj.mj=?
   });
   $sth->execute($mj);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{mj}=$mj;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o statu
sub stat {
   my ($pkg_p, $stat)=@_;
   my $sth=$dbh->prepare(q{
      select
         Staty.*
      from
         Obchod.Staty
      where
         Staty.stat=?
   });
   $sth->execute($stat);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{stat}=$stat;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o typu dopravy
sub typdopravy {
   my ($pkg_p, $typdopravy)=@_;
   my $sth=$dbh->prepare(q{
      select
         Typdopravy.*
      from
         Obchod.Typdopravy
      where
         Typdopravy.typdopravy=?
   });
   $sth->execute($typdopravy);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o typu uhrady
sub typuhrady {
   my ($pkg_p, $typuhrady)=@_;
   my $sth=$dbh->prepare(q{
      select
         Typuhrady.*
      from
         Obchod.Typuhrady
      where
         Typuhrady.typuhrady=?
   });
   $sth->execute($typuhrady);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi informace o forme objednavky
sub formaobj {
   my ($pkg_p, $formaobj)=@_;
   my $sth=$dbh->prepare(q{
      select
         Formaobj.*
      from
         Obchod.Formaobj
      where
         Formaobj.formaobj=?
   });
   $sth->execute($formaobj);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci v hashi poznamku k vydejce zadanou zasobovanim
sub vydejka_poznzas {
   my ($pkg_p, $mat,$str,$cisvyd)=@_; # klic je kapku divnej (vzhledem ke klici v Vyroba_planovani.Vydejky), ale takovej uz byl v Material.Material_pozn
   # pripoustim si jen jedinou poznamku
   my $sth=$dbh->prepare(q{
      select
         substring(Material_pozn.pozn,13) as poznzas
      from
         Material.Material_pozn
      where
         Material_pozn.mat=? and
         Material_pozn.druh="VYD" and
         substring(Material_pozn.pozn,1,?)=?
      order by
         Material_pozn.porc asc
   });
   my $key=$str.' '.$cisvyd;
   $sth->execute($mat,length($key),$key);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

#- vraci zaznam objednavky
sub objnak {
   my ($pkg_p, $cnobj)=@_;
   my $sth=$dbh->prepare(q{
      select
         Objnak.*
      from
         Obchod.Objnak
      where
         Objnak.org=? and
         Objnak.cnobj=?
   });
   $sth->execute(get_env("org"),$cnobj);
   my $ref=$sth->fetchrow_hashref;
   $sth->finish;
   $$ref{_exist}=$sth->rows;
   return $ref;
}

return 1;

