package Kusovnik_norm;

my $pkg="Kusovnik_norm";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use Kusovnik;
use Info;
use Vyroba;
use Spolecnost;


#==== Globalni promena tohohle balicku
my $dbh=My->dbh;


#- kusovnik prochazejici i normativy zvrchu dolu - rozpad se zastavuje na jinych strediscich nez je dano ve $$vazba{_str} nebo prejstr je strediskem skladu RV
sub kusovnik_str {
   my ($pkg_p, $vazba)=@_;
   # zjisteni informaci o zakazce
   my $ref_zak=Info->zak($$vazba{zakn});
   # vytvoreni posledniho imaginarniho normativu - nakonec ale to prochazim reverzne obracene... takze tenhle kmint bude pri pruchodu prvni
   #   a od ktereho kmint (mimo nej) budu cist zaznamy v normativech
   my $ref_norm_1;
   my $normativy;
   if($$vazba{sled}==0) {
      $$ref_norm_1{kmint}=$$vazba{_odkmint}; # u nulteho sledu -> inventovany kmint
      $$ref_norm_1{kmstr}=$$vazba{_str};
      # ziskani normativu
      $normativy=Vyroba->normativy($ref_zak, $$ref_norm_1{kmint},$$ref_norm_1{kmstr}); # jen kmint "vyssi" (hodnotou mysleno nizsi) nez je ($$ref_norm_1{kmint},$$ref_norm_1{kmstr})
      ## ZMENA 2003-01-12 radky nize jsem pridal, jelikoz jinak byly spatne zjisteny operace odoper dooper a u odvadeni doslo ke spatnemu zaceneni
      ## ovsem asi mnohem lepsi by bylo dobre radky nize presunout do funkce PokudNeni_odoper_dooper_UrciJe
      my $normativ_odoper_dooper=Vyroba->normativypoc($ref_zak,$$ref_norm_1{kmint},$$ref_norm_1{kmstr});
      $$ref_norm_1{odoper}=$$normativ_odoper_dooper{odoper};
      $$ref_norm_1{dooper}=$$normativ_odoper_dooper{dooper};
   }
   else {
      # nema tu byt i kmint 998  - mozna jen v nekterych pripadech, pak to musis, ale zpravit i dole ???
      #                          - ne nevsouvej ho - tam, kde s nim opravdu potrebuji pracovat - napriklad zjistovani stavu, to delej spolecne s kmint 999
      #                          - POZOR rozhodne si rozmysli pripadne vsunuti v jinycg algoritmech na tomhle zavyslem by to mohlo udelat obrovskou paseku!!! - proste umele vkladam jen 999
      $$ref_norm_1{kmint}="999"; # u dalsich sledu kmint 999 == vedeni hotovych elementu na stavu montazni dilny
      $$ref_norm_1{kmstr}=$$vazba{kmstr};
      $normativy=Vyroba->normativy($ref_zak, undef,undef); # vsechno - je rychlejsi nez s omezenim na kmint,kmsstr
                                                           # !! pozor mlcky predpokladas, ze pak nasledne vlozeny 999 kmint a prislusne str (z $ref_norm_1) se nebude shodovat s zadnym co vrati fce normativy, predpoklad je to spravny, ale pokud by nejake normativy nebyly ok tak by to splneno nebylo a ty bys to tam mel dvakrat... !!
   }
   my $ref_norm_next=$$normativy[-1];
   $ref_norm_1=$pkg->PokudNeni_odoper_dooper_UrciJe($ref_norm_1);
   $$ref_norm_1{pd}=0;
   $$ref_norm_1{dav}=$$vazba{dav};
   $$ref_norm_1{proczm}=0;
   $$ref_norm_1{umely}=1;
   # urzeni znprik u prvniho (imaginarniho) kmint
   my $znprik_1;
   if($$vazba{sled}==0) {
      if($$ref_norm_1{kmint} eq "999") {
         $znprik_1="9"; # znak specialne urcen jen pro vypocet potreby zakazek - chci rozlisit zakazky na kmint 999, ktere maji byt odvedeny dle Objednavek od zakazek na kmint 999, ktere ma dodat jna kmorg
      }
      else {
         $znprik_1="0"; # hmm ani nevim proc to tu mam - sem to snad nikdy nejde
      }
   }
   else { # pokud se nepletu, tyka se jedine kmint 999 na nizsich sledech
      # !!! POZOR TUHLE PODMINKU V BLEDE MODRYM MAS NIZE - ZMENA ZDE SE MUSI PROMITNOUT I TAM
      if($$ref_norm_next{kmstr} ne $$vazba{kmstr}) {
         $znprik_1="2"; # znak specialne urcen jen pro vypocet potreby zakazek - na nasledujicim stredisku dochazi ke zmene predavky na jine stredisko (napriklad temlene cocky) a ja chci tenhle kmint 999 ve vypoctu potreby zachovat
      }
      else {
         $znprik_1="8";
      }
   }
   # dodstr
   if(defined($$ref_norm_next{kmstr})) {
      $$ref_norm_1{dodstr}=$$ref_norm_next{kmstr};
   }
   elsif($$ref_zak{kmorg} eq "0") {
      $$ref_norm_1{dodstr}=Vyroba->dodstr($ref_zak,$$ref_norm_1{kmint},$$ref_norm_1{kmstr});
   }
   elsif($$ref_zak{kmorg} ne get_env("org")) {
      $$ref_norm_1{dodstr}=Vyroba->dodstr_jinakmorg($ref_zak);
   }
   # prejstr
   if($$vazba{sled}==0 and defined($$vazba{strprij})) { # vyuzito u odvadeni - prebijim pripadnou informaci z normativu
      $$ref_norm_1{prejstr}=$$vazba{strprij};
   }
   elsif(!defined($$ref_norm_1{prejstr})) {
      $$ref_norm_1{prejstr}="";
   }
   # poznamka: nevytvarim udaje "kmorg" a "ch" - je problematicke zda kmorg mam dat kmorg zakazky a nebo org strediska (coz se muze lisit...)
   # pridani posledniho imaginarniho kmint
   push(@{$normativy},$ref_norm_1);
   # prochazeni po kmint
   foreach my $ref_norm (reverse @{$normativy}) {
      my $znprik;
      if(defined($znprik_1)) {
         $znprik=$znprik_1;
         $znprik_1=undef;
         # presunuto z Vyroba_planovani
         $$vazba{Vyroba_stav}*=$$vazba{mnoz};
      }
      else {
         # kmstr na kmint je jine nez pocitane nebo kmstr je rovno prejstr (prodavani samosobe) nebo prejstr je sklad RV => zaznamenavam (predesly normativni zaznam)
         # pokud se vsak jedna o vypocet vyrobnich prikazu ci zjistovani potreby zakazy, tak zde rozpad nezastavuji ale zapamatuji si, ze u odvadeni by zde doslo k zastaveni rozpadu
         ## VAZNA ZMENA 2002-04-14, puvodne prvni podminka v if znela "$$ref_norm{kmstr} ne $$vazba{_str}"
         ## premyslim, ze druha podminka by mozna mela znit "$$ref_norm{prejstr} eq $$vazba{kmstr}", ale asi je to jedno - mela by zajistovat moznost prodavani strediska samo sobe (???)
         # !!! POZOR TUHLE PODMINKU V BLEDE MODRYM MAS VYSE - ZMENA ZDE SE MUSI PROMITNOUT I TAM
         if($$ref_norm{kmstr} ne $$vazba{kmstr}) {
            $znprik="0";
            $pkg->dofcezaznam($vazba,0); # dobre pro oznackovani, kde zastavuji rozpad a se stavem ceho se hybe
            if(!$$vazba{_potreba}) {
               return; # ukoncuji beh fce
            }
         }
         else {
            $znprik="8";
         }
      }
      # zapamatovani si tohohle sledu normativu (pro pripadny jeho zapis v dalsim kroku)
      $$vazba{kmint}=$$ref_norm{kmint};
      $$vazba{kmstr}=$$ref_norm{kmstr};
      $$vazba{dodstr}=$$ref_norm{dodstr};
      $$vazba{prejstr}=$$ref_norm{prejstr};
      $$vazba{dooper}=$$ref_norm{dooper};
      $$vazba{odoper}=$$ref_norm{odoper};
      $$vazba{pd}=$$ref_norm{pd}; #
      $$vazba{dav}=$$ref_norm{dav}; #
      $$vazba{proczm}=$$ref_norm{proczm}; #
      $$vazba{umely}=$$ref_norm{umely};
      $$vazba{kmorg}=$$ref_zak{kmorg};
      $$vazba{ch}=$$ref_zak{ch};
      # navyseni mnozczm o zmetky
      $$vazba{mnozczm}+=$$vazba{mnozczm}*$$vazba{proczm}*0.01;
      # zaznam znaku pro vyrobni prikazy - 0 = tohle se odvadi a ma to pevne prikazy;  8 = primo tohle se neodvadi a nema to pevne prikazy
      $$vazba{znprik}=$znprik;
      $pkg->dofcepruchod($vazba);
   }
   # zaznamenavam nejnizsi kmint pokud je zak z jine org nebo pokud se jiz nerozpadla
   if($$vazba{kmorg} ne get_env("org") or !Kusovnik->kusovnik($vazba)) { # poznamka: u potreby danne zakazky sem pujdu u te zkoumane zakazky vzdy, jelikoz cerpam z optimalizovaneho kusovniku v pomocne tabulce a u sestav nepoznam, ze jde o sestavy, jelikoz optimalizovany kusovnik neobsahuje jeji elementy a mne se jevi jako nesestava (napriklad temlene cocky...)
      $$vazba{znprik}="0";
      $pkg->dofcezaznam($vazba,1);
   }
}
#- spusteni "zaznamenavaci" fce na "konci" "normativoveho kusovniku"
sub dofcezaznam {
   my ($pkg_p, $vazba,$posledni)=@_;
   if(defined($$vazba{_funkce_str})) {
      my ($pkg_fcezaznam,$fcezaznam)=split(/\-\>/,$$vazba{_funkce_str});
      $pkg_fcezaznam->$fcezaznam($vazba,$posledni);
   }
}
#- spusteni "pruchodove" fce u kazdeho kmint, kterym prochazim
sub dofcepruchod {
   my ($pkg_p, $vazba)=@_;
   if(defined($$vazba{_funkce_str_pruchod})) {
      my ($pkg_fcepruchod,$fcepruchod)=split(/\-\>/,$$vazba{_funkce_str_pruchod});
      $pkg_fcepruchod->$fcepruchod($vazba);
   }
}

#- pomocna fce uzivajici k "vymysleni" nekterych udaju, pokud nebyl nalezen normativ u prislusneho kmint
# fce je uzivana i v Vyroba_evidence.pm ale i jinde
sub PokudNeni_odoper_dooper_UrciJe {
   my ($pkg_p, $ref_norm)=@_;
   if(!defined($$ref_norm{dooper})) {
      if($$ref_norm{kmint} eq "999") {
         $$ref_norm{dooper}="999";
      }
      else {
         $$ref_norm{dooper}="000";
      }
   }
   if(!defined($$ref_norm{odoper})) {
      # zmena 2002-04-23, drive zde byl jediny radek: $$ref_norm{odoper}="";
      if($$ref_norm{kmint} eq "999") {
         $$ref_norm{odoper}="999";
      }
      else {
         $$ref_norm{odoper}="000";
      }
   }
   return $ref_norm;
}

return 1;

