package Vyroba_planovani;

# vyrobni prikaz rika kolik ma byt odvedeno ks z danneho kmint

my $pkg="Vyroba_planovani";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use Info;
use Write;
use Kusovnik;
use Kusovnik_norm;
use Date::Format;
use Vyroba;
use Vyroba_planovani_vydejky;
use Vyroba_planovani_objednavky;
use Conversion;

#==== Globalni promena tohohle balicku
my %potreba;


#==== Dulezite fce pro manipulaci s globalni promennou %potreba tohohle balicku
# fce nuluju globalni promennou %potreba tohohle balicku
sub delvar_potreba {
   %potreba=();
}
# fce vraci pointer na globalni promennou %potreba tohohle balicku
# - dulezite, abych mohl udaje ziskat do nejakeho externigho baliku
sub getvar_potreba {
   return \%potreba;
}


#==== Napojeni na DB
my $dbh=My->dbh;
#- dotaz pro zjisteni co maji strediska v prislusnem terminu odvest (a take Co jiz na stredisku je)
my $sth_objednavky_vse=$dbh->prepare(q{
   select
      Objednavky.zak,
      Objednavky.termin,
      (Objednavky.kszad-Objednavky.ksvyk) as ks,
      Objednavky.strodv,
      Objednavky.sor,
      Objednavky.zakaznikico
   from
      Vyroba_planovani.Objednavky
   where
      Objednavky.org=? and
      Objednavky.kszad>Objednavky.ksvyk
});
#- ten samy dotaz jako vyse, ale s omezenim jen na "urgentni" objednavky
my $sth_objednavky_urg=$dbh->prepare(q{
   select
      Objednavky.zak,
      Objednavky.termin,
      (Objednavky.kszad-Objednavky.ksvyk) as ks,
      Objednavky.strodv,
      Objednavky.sor,
      Objednavky.zakaznikico
   from
      Vyroba_planovani.Objednavky
   where
      Objednavky.org=? and
      Objednavky.kszad>Objednavky.ksvyk and
      Objednavky.pozn like "!%"
});
# dotaz zjistujici seznam kmint v normativech
my $sth_kmint=$dbh->prepare(q{
   select
      Normativy.kmint
   from
      Vyroba_planovani.Normativy
   where
      Normativy.org=? and
      Normativy.zak=? and
      Normativy.platod<=? and
      Normativy.platdo>=?
   order by
      Normativy.kmint desc
});
# dotaz pro praci s Vyroba_stav, ale pro kmint 998 - zde scitam stav na vsech strediscich (coz mozna neni pro vsechny ucely nejlepsi)
my $sth_stav_998=$dbh->prepare(q{
   select
      sum(Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv) as stav
   from
      Vyroba_evidence.Vyroba_stav
   where
      Vyroba_stav.org=? and
      Vyroba_stav.zak=? and
      Vyroba_stav.kmint="998" and
      (Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv)>0
});
# dotaz pro praci s Vyroba_stav, ale pro kmint 999 a 998 - zde scitam stav na vsech strediscich (coz mozna neni pro vsechny ucely nejlepsi)
my $sth_stav_998_999=$dbh->prepare(q{
   select
      sum(Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv) as stav
   from
      Vyroba_evidence.Vyroba_stav
   where
      Vyroba_stav.org=? and
      Vyroba_stav.zak=? and
      Vyroba_stav.kmint in("998","999") and
      (Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv)>0
});
# dotaz pro praci s Vyroba_stav, ale pro vsechnu kmint - zde scitam stav na vsech strediscich
my $sth_stav_vse=$dbh->prepare(q{
   select
      sum(Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv) as stav
   from
      Vyroba_evidence.Vyroba_stav
   where
      Vyroba_stav.org=? and
      Vyroba_stav.zak=? and
      (Vyroba_stav.ksvych+Vyroba_stav.ksprij-Vyroba_stav.kszm-Vyroba_stav.ksodv)>0
});
# dotaz zjistujici nesplnene VP
my $sth_vyrprikazy=$dbh->prepare(q{
   select
      Vyrprikazy.datkon,
      Vyrprikazy.kmint,
      Vyrprikazy.kszad-Vyrprikazy.ksvyk as ks,
      Vyrprikazy.str,
      Vyrprikazy.sor
   from
      Vyroba_planovani.Vyrprikazy
   where
      Vyrprikazy.org=? and
      Vyrprikazy.zak=? and
      Vyrprikazy.kszad>Vyrprikazy.ksvyk
});
# dotaz zjistujici nevidane vydejky
my $sth_vydejky=$dbh->prepare(q{
   select
      Vydejky.datpoz,
      Vydejky.kspoz-Vydejky.ksvyd as ks,
      Vydejky.str,
      Vydejky.sor
   from
      Vyroba_planovani.Vydejky
   where
      Vydejky.org=? and
      Vydejky.zak=? and
      Vydejky.kspoz>Vydejky.ksvyd
});



#======================================
#- fce vracejici ica spolecnosti, ktere jsou povazovany za interni - z toho poznavam interni objednavky od externich
# !!! pozor fci uzivas i v ramci importu ext. obj. optiky (/Servis/Import/impobj.7.phtml), ale i jinde...
sub ico_int {
   #       dalekohled pristroje  optika     mechanika
   return ("61974625","47677015","47677023","47677155");
}


#======================================
#- hlavni funkce pocitajici a zaznamenavajici interni objednavky
# funkce je uzita programem na vypocet internich objednavek
sub objednavky_vypocet {
   $pkg->delvar_potreba;
   my $objednavky={};
   set_env("datum", My->date_now);
   #- Co maji strediska v prislusnem terminu odvest (a take Co jiz na stredisku je)
   ### POZNAMKA - zde by mozna bylo dobre vyjit ze schovanych objednavek v Objednavky_navrh a ne primo z Objednavek (kazdopadne mezi uschovou do Objednavky_navrh a vypoctem je stop stav, takze by to melo byt identicke a tedy jedno!!! - ovsem...)
   my $sth_objednavky;
   if(!get_env("urgobj")) {
      $sth_objednavky=$sth_objednavky_vse;
   }
   else {
      $sth_objednavky=$sth_objednavky_urg;
   }
   $sth_objednavky->execute(get_env("org"));
   while(my $ref_objednavky=$sth_objednavky->fetchrow_hashref) {
      if($$ref_objednavky{termin} ge My->date_now) {
         set_env("datum", $$ref_objednavky{termin});
      }
      else {
         set_env("datum", My->date_now);
      }
      Kusovnik_norm->kusovnik_str(
         Kusovnik->ini({
            zak =>         $$ref_objednavky{zak},
            mnoz =>        $$ref_objednavky{ks},
            _funkce =>     "Kusovnik_norm->kusovnik_str",
            _funkce_str => "$pkg->objednavky_dopln",
            _funkce_str_pruchod => "$pkg->potreba_dopln",
            _str =>        $$ref_objednavky{strodv}, # u prvniho sledu se zapise do kmstr, z ktereho ja pak na konci beru zakaznikstr - pokud vubec nedojde k rozpadu, tedy v objednavkach org je zakazka co dana org vubec nedela zapisi do zakstr primo tohle, jinak kmstr posledniho kmint, kam az sem rozpadal (rozpadam jen na dane org)
            _odkmint =>    "999",
            termin =>      $$ref_objednavky{termin},
            _indmax =>     1,
            _potreba =>    1,
            _objednavky => $objednavky
         })
      );
   }
   $sth_objednavky->finish;
   #- ZAPIS navrhu objednavek
   set_env("datum", My->date_now);
   my $ref_org=Info->org;
   my $zakaznikico=$$ref_org{ico};
   # pokud jde o vypocet "urgetnich" objednavek, tak z jiz existujicim navrhem nic nedelam
   # poznamka: pokud jde o vypocet "urgetnich" objednavek predpokladam existenci jiz nejakeho predesleho "hlavniho" navrhu - to, aby nedochazelo k problemum co je vlastne aktualni navrh
   if(!get_env("urgobj")) {
      #- "Vymaz" pripadne jiz spoctenych internich objednavek v dannem mesici
      #  -mazu jen ty, kde nebylo nic vykazano
      ## ZMENA 2003-01-06 jeste nemazu objednavky z Abry - zacinajici retezcem "OD-", neni to moc hezke a chce to organizovazt jinak...
      my $sth=$dbh->prepare(q{
         delete from
            Vyroba_planovani.Objednavky_navrh
         where
            Objednavky_navrh.org!=? and
            Objednavky_navrh.zakaznikico=? and
            Objednavky_navrh.obdobivyp=? and
            Objednavky_navrh.ksvyk=0 and
            Objednavky_navrh.cisobj not like "OD-%"
      });
      $sth->execute(get_env("org"),$zakaznikico,My->period_now); # objednavky spolecnosti sebe na sebe nepovazuji za interni a tedy je nemazu
      #  -tam kde bylo neco vykazano - dorovnam kszad na ksvyk a zmenim cisobj, aby nedoslo ke kolizi klicu pro nove spoctene
      # zjisteni posledniho transformovaneho cisobj
      my $sth_cisobj=$dbh->prepare(q{
         select
            substring(Objednavky_navrh.cisobj,15,2) as poradi
         from
            Vyroba_planovani.Objednavky_navrh
         where
            Objednavky_navrh.org=? and
            Objednavky_navrh.zak=? and
            Objednavky_navrh.zakaznikico=? and
            Objednavky_navrh.zakaznikstr=? and
            Objednavky_navrh.termin=? and
            Objednavky_navrh.cisobj like ? and
            Objednavky_navrh.skup=? and
            Objednavky_navrh.obdobivyp=?
         order by
            Objednavky_navrh.cisobj desc
         limit
            1
      });
      my $sth_upd=$dbh->prepare(q{
         update
            Vyroba_planovani.Objednavky_navrh
         set
            Objednavky_navrh.cisobj=?,
            Objednavky_navrh.kszad=?
         where
            org=? and
            zak=? and
            zakaznikico=? and
            zakaznikstr=? and
            termin=? and
            cisobj=? and
            skup=? and
            obdobivyp=?
      });
      # prochazeni splnenyma ci statecne splnenyma objednavkama, kde jeste nedoslo k transformaci cisobj a k dorovnani kszad na ksvyk
      ## ZMENA 2003-01-06 jeste nepracuji s objednavkami z Abry - zacinajici retezcem "OD-", neni to moc hezke a chce to organizovazt jinak...
      ## ZMENA 2003-01-08 (neplati!!! - viz pozn nize) vymenil jsem podminku "length(Objednavky_navrh.cisobj)!=16 and" za "Objednavky_navrh.kszad!=Objednavky_navrh.ksvyk and"
      ## ZMENA 2003-04-11 - co chci? aby nedoslo k zdvojeni klicu, tedy podminka by mela znit: zmen cislo obj u int. objednavek tam, kde jsi tak jeste neucinil - proto jsem zmenil podminku "Objednavky_navrh.kszad!=Objednavky_navrh.ksvyk and" na "length(Objednavky_navrh.cisobj)=13 and" (predpokladam, ze str ma vzdy 4 mista)
      my $sth=$dbh->prepare(q{
         select
            Objednavky_navrh.*
         from
            Vyroba_planovani.Objednavky_navrh
         where
            Objednavky_navrh.org!=? and
            Objednavky_navrh.zakaznikico=? and
            Objednavky_navrh.obdobivyp=? and
            length(Objednavky_navrh.cisobj)=13 and
            Objednavky_navrh.cisobj not like "OD-%"
      });
      $sth->execute(get_env("org"),$zakaznikico,My->period_now);
      while(my $ref=$sth->fetchrow_hashref) {
         my $cisobj=substr($$ref{cisobj},0,13);
         $sth_cisobj->execute(
            $$ref{org},$$ref{zak},$$ref{zakaznikico},$$ref{zakaznikstr},$$ref{termin},
            $cisobj.'-__', ## ZMENA 2003-04-11 nahradil jsi "%" znaky "__" spravne by to spis jeste melo znit, ze ty znaky musi byt cisla... ale zatim to nezlepsuj
            $$ref{skup},
            $$ref{obdobivyp}
         );
         my $ref_cisobj=$sth_cisobj->fetchrow_hashref;
         $sth_cisobj->finish;
         my $poradi=sprintf("%2.2d",$$ref_cisobj{poradi}+1);
         $cisobj.='-'.$poradi;
         $sth_upd->execute(
            $cisobj, $$ref{ksvyk},
            $$ref{org},
            $$ref{zak},
            $$ref{zakaznikico},
            $$ref{zakaznikstr},
            $$ref{termin},
            $$ref{cisobj},
            $$ref{skup},
            $$ref{obdobivyp}
         );
      }
      $sth->finish;
   }
   # Oznaceni predchoziho navrhu jako jiz neaktualniho - pokud se nepletu ma vliv jen na aktualizaci - tedy oznacene neaktualni radky v navrhu objednavek jiz nebude mozne aktualizovat
   Vyroba_planovani_objednavky->oznac_za_neaktnavrh_zakaznikico($zakaznikico);
   # priprava dotazu na zaznam vypocteneho navrhu
   ## ZMENA 2002-12-12 (neplati uplne - viz poznamka nize!!!) - NOVE jsem do insert dodal sluvko "ignore" - kvuli "urgentnim" objednavkam (nove spoctene urgetni objednavky budou vlozeny jen za predpokladu, ze v navrhu neni jiz nejaka se stejnym klicem)
   ## ZMENA 2003-04-11 - sluvko ignore jsem se rozhodl obecne zrusit a je funkcni jen u urgentnich objednavek (je to proto, ze v klasickych objednavkach ke krizeni klicu nemuze dojit a pokud doslo, je nekde chyba zde v programu vyse, ci nekdo nejak nekorektne zmenil cislo int obj...)
   my $dotaz;
   if(!get_env("urgobj")) {
      $dotaz=q{
         insert into
            Vyroba_planovani.Objednavky_navrh
      };
   }
   else {
      $dotaz=q{
         insert ignore into
            Vyroba_planovani.Objednavky_navrh
      };
   }
   $dotaz.=q{
         (
            Objednavky_navrh.org,
            Objednavky_navrh.zak,
            Objednavky_navrh.zakaznikico,
            Objednavky_navrh.zakaznikstr,
            Objednavky_navrh.termin,
            Objednavky_navrh.cisobj,
            Objednavky_navrh.skup,
            Objednavky_navrh.obdobivyp,
            Objednavky_navrh.strodv,
            Objednavky_navrh.kszad,
            Objednavky_navrh.ksvyk,
            Objednavky_navrh.datvyk,
            Objednavky_navrh.cena,
            Objednavky_navrh.eso,
            Objednavky_navrh.sor,
            Objednavky_navrh.pozn,
            Objednavky_navrh.znmv,
            Objednavky_navrh.datzapis,
            Objednavky_navrh.uzivzapis
         )
      values
         (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
   };
   my $sth=$dbh->prepare($dotaz);
   # priprava zaznamu na zjisteni prodejni ceny
   my $sth_cena=$dbh->prepare(q{
      select
         Zakazky_cenik.cena
      from
         Zakazky.Zakazky_cenik
      where
         Zakazky_cenik.zak=? and
         Zakazky_cenik.platod<=? and
         Zakazky_cenik.platdo>=?
   });
   # ponizeni potreby o stav a zapis
   my $pozn; ## ZMENA 2002-12-10 - puvodne vzdy jen "INT"
   if(!get_env("urgobj")) {
      $pozn="INT";
   }
   else {
      $pozn="!INT";
   }
   foreach my $zak (keys %{$objednavky}) {
      foreach my $kmint (keys %{$$objednavky{$zak}}) { # melo by vracen jen jediny kmint (asi 999)
         foreach my $str (keys %{$$objednavky{$zak}{$kmint}}) {
            my $terminlast;
            # ponizeni potreby o stav
            my $korekce=$potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad};
            my $info_stav=Info->vyroba_stav($zak,$kmint,$str);
            if($$info_stav{stav}>0) {
               $korekce+=$$info_stav{stav};
            }
            foreach my $termin (sort keys %{$$objednavky{$zak}{$kmint}{$str}}) {
               if($korekce>=$potreba{$zak}{$kmint}{$str}{$termin}{kszad}) {
                  $korekce-=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
                  delete($$objednavky{$zak}{$kmint}{$str}{$termin});
                  delete($potreba{$zak}{$kmint}{$str}{$termin});
               }
               else {
                  $potreba{$zak}{$kmint}{$str}{$termin}{kszad}-=$korekce;
                  $terminlast=$termin;
                  last;
               }
            }
            # v nekterych specialnich pripadech objednavky davkuji
            ## ZMENA 2003-02-28 - problem plastickych hmot, kde je dulezite objednavky zdavkovat dle normativu vyrobce (problem Zapletal)
            if($potreba{$zak}{$kmint}{$str}{$terminlast}{ch} eq "43" or $potreba{$zak}{$kmint}{$str}{$terminlast}{ch} eq "44") {
               # zjisteni udaje davky
               my $orgE=get_env("org");
               set_env("org",$potreba{$zak}{$kmint}{$str}{$terminlast}{kmorg});
               my $krok;
               if($kmint eq "999") {
                  $krok=-1;
               }
               my $info_normativ=Info->normativy($zak,$kmint,$krok);
               my $dav=$$info_normativ{dav};
               set_env("org",$orgE);
               # slouceni dle davky
               my ($termindav, $datdav);
               foreach my $termin (sort keys %{$$objednavky{$zak}{$kmint}{$str}}) {
                  # termin nepada do davky
                  if($datdav le $termin) { # opravdu "le" a ne "lt"?
                     $termindav=$termin;
                     $datdav=My->date_adddecade($termindav,$dav);
                  }
                  # termin pada do davky
                  else {
                     # davkovani kusu
                     $potreba{$zak}{$kmint}{$str}{$termindav}{kszad}+=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
                     # sortiment
                     $potreba{$zak}{$kmint}{$str}{$termindav}{sor}=Kusovnik->sor($potreba{$zak}{$kmint}{$str}{$termin}{sor},$potreba{$zak}{$kmint}{$str}{$termindav}{sor});
                     # likvidace objednavky jejichz kusy jsem jiz dal do davky
                     delete($$objednavky{$zak}{$kmint}{$str}{$termin});
                     delete($potreba{$zak}{$kmint}{$str}{$termin});
                  }
               }
            }
            ## KONEC - ZMENA 2003-02-28
            foreach my $termin (sort keys %{$$objednavky{$zak}{$kmint}{$str}}) {
               # poznamka - doplnujici udaje budu ziskavat na datum platnosti zjisteneho terminu (pokud jde vsak o minulost tak na aktualni datum)
               if($termin ge My->date_now) {
                  set_env("datum", $termin);
               }
               else {
                  set_env("datum", My->date_now);
               }
               # Zjisteni objednavaneho mnozstvi
               my $kszad=sprintf("%.0f",$potreba{$zak}{$kmint}{$str}{$termin}{kszad});
               # Zjisteni dalsich udaju pred zapisem
               # kmorg zakazky a tedy org v ktere bude objednavka zapsana (a ktera zakazku vyrabi)
               my $proorg=$potreba{$zak}{$kmint}{$str}{$termin}{kmorg};
               # zakaznikstr - totozne s kmstr, nalezenem na nejnizsim kmint v org kde delam rozpad (nikoliv org v ktere bude objednavka zapsana)
               ##my $zakaznikstr=$potreba{$zak}{$kmint}{$str}{$termin}{str};
               my $zakaznikstr=$str;
               # cisobj
               my $cisobj="$zakaznikstr/$termin"; $cisobj=~s/-//g;
               # strodv - nejsem si jist, ale melo by to byt kmstr z posledniho kmint u org v ktere bude objednavka zapsana
               my $strodv=$potreba{$zak}{$kmint}{$str}{$termin}{dodstr};
               # prodejni cena
               $sth_cena->execute($zak,get_env("datum"),get_env("datum"));
               my $ref_cena=$sth_cena->fetchrow_hashref;
               $sth_cena->finish;
               my $cena=1*$$ref_cena{cena};
               # sortiment
               my $sor=$$objednavky{$zak}{$kmint}{$str}{$termin}{sor};
               # Samotny zapis
               $sth->execute(
                  $proorg,
                  $zak,
                  $zakaznikico,
                  $zakaznikstr,
                  $termin,
                  $cisobj,
                  "00", ## ZMENA 2003-01-16 - skupinu vyplnuji "00", jinak nejdou objednavky upravovat
                  My->period_now,
                  "$strodv",
                  $kszad,
                  0,
                  "0000-00-00",
                  $cena,
                  "D21",
                  $sor,
                  $pozn,
                  "0",
                  My->datetime_now,
                  My->remote_user
               );
            }
         }
      }
   }
   # pokud slo o vypocet urgetnich objednavek, je treba ve vychozim souboru objednavek zrusit znacku urgentnosti
   if(get_env("urgobj")) {
      Vyroba_planovani_objednavky->zrus_znak_urgence(get_env("org"));
   }
}


#======================================
#- hlavni funkce pocitajici a zaznamenavajici vyrobni prikazy
# funkce je uzita programem na vypocet vyrobnich prikazu
sub prikazy_vypocet {
   set_env("datum", My->date_now);
   # uschovani puvodnich prikazu do tabulky Vyrprikazy_puvod - dulezite pro tisk zmeny vyrobnich prikazu
   if(!get_env("urgobj")) {
      my $sth=$dbh->prepare(q{
         delete from
            Vyroba_planovani.Vyrprikazy_puvod
         where
            Vyrprikazy_puvod.org=?
      });
      $sth->execute(get_env("org"));
      my $sth=$dbh->prepare(q{
         insert into
            Vyroba_planovani.Vyrprikazy_puvod
         select
            Vyrprikazy.*
         from
            Vyroba_planovani.Vyrprikazy
         where
            Vyrprikazy.org=?
      });
      $sth->execute(get_env("org"));
   }
   # samotny vypocet...
   $pkg->delvar_potreba;
   #- Co maji strediska v prislusnem terminu odvest (a take Co jiz na stredisku je)
   my $sth_objednavky;
   if(!get_env("urgobj")) {
      $sth_objednavky=$sth_objednavky_vse;
   }
   else {
      $sth_objednavky=$sth_objednavky_urg;
   }
   $sth_objednavky->execute(get_env("org"));
   while(my $ref_objednavky=$sth_objednavky->fetchrow_hashref) {
      if($$ref_objednavky{termin} ge My->date_now) {
         set_env("datum", $$ref_objednavky{termin});
      }
      else {
         set_env("datum", My->date_now);
      }
      Kusovnik_norm->kusovnik_str(
         Kusovnik->ini({
            zak =>         $$ref_objednavky{zak},
            mnoz =>        $$ref_objednavky{ks},
            _funkce =>     "Kusovnik_norm->kusovnik_str",
            _funkce_str => undef, # predtim zde bylo: "$pkg->potreba_dopln_posledni"
            _funkce_str_pruchod => "$pkg->potreba_dopln",
            _str =>        $$ref_objednavky{strodv}, # ZMENA 2002-06-13 drive tu byla "*"
            _odkmint =>    "999",
            termin =>      $$ref_objednavky{termin},
            sor =>         $$ref_objednavky{sor},
            _indmax =>     1,
            _potreba =>    1
         })
      );
   }
   $sth_objednavky->finish;
   #- Zapis VP
   set_env("datum", My->date_now);
   # zruseni VP s znprik=8 (casem dodej ruseni jiz nejakou dobu splnenych prikazu - to jsi zatim vyhodil)
   if(!get_env("urgobj")) {
      my $sth=$dbh->prepare(q{
         delete from
            Vyroba_planovani.Vyrprikazy
         where
            Vyrprikazy.org=? and
            Vyrprikazy.znprik=?
      });
      $sth->execute(get_env("org"),"8");
   }
   # zapis 1 do kolonky znprik a zapis znmvlr => jen nove zapsane zaznamy budou mit 0
   ## ZMENA 2003-03-24 - poznamka nize jiz neplati - jelikoz mi stale u "urgentnich" objednavek pak vybihaly materialove vydejky na veci, kde byl rucne napsan prikaz a nebyla k nemu vygenerovana vydejka (u toho rucniho prikazu mel byt dan znak prikazu 1, ale to se zel nedelo), tak nyni i u urgentnich objednavek prepisuji jiz existujici vyrobni prikazy ze znaku 0 na 1 - tedy vydejky pak opravdu vyjedou jen na to co souvisi s urgentnimi objednavkami (teda pokud se tam nejakou chybou nezaplete jeste neco se znprik 8)
   ## poznamka (jiz neplati): pri vypoctu z "urgentnich" objednavek to take nedelam a to, ze mi nevyjede na jeden prikaz materialova vydejka podruhe si zajistuji kontrolou na urovni funkce vypoctu materialovych vydejek z vyr. prikazu
   my $sth=$dbh->prepare(q{
      update
         Vyroba_planovani.Vyrprikazy
      set
         Vyrprikazy.znprik=?,
         Vyrprikazy.znmvlr=?
      where
         Vyrprikazy.org=? and
         Vyrprikazy.znprik!="8"
   });
   $sth->execute("1","22", get_env("org"));
   # Prochazeni VP - priprava dotazu
   my $sth_vp=$dbh->prepare(q{
      select
         Vyrprikazy.*,
         (Vyrprikazy.kszad-Vyrprikazy.ksvyk) as kspokryva
      from
         Vyroba_planovani.Vyrprikazy
      where
         Vyrprikazy.org=? and
         Vyrprikazy.znprik=1 and
         Vyrprikazy.kszad>Vyrprikazy.ksvyk
      order by
         Vyrprikazy.zak asc,
         Vyrprikazy.kmint asc,
         Vyrprikazy.prik asc
   });
   # Uprava existujiciho VP - priprava dotazu
   my $sth_vpupd=$dbh->prepare(q{
      update
         Vyroba_planovani.Vyrprikazy
      set
         Vyrprikazy.datzac=?,
         Vyrprikazy.datkon=?
      where
         Vyrprikazy.org=? and
         Vyrprikazy.zak=? and
         Vyrprikazy.kmint=? and
         Vyrprikazy.prik=?
   });
   # Zaznam noveho VP - priprava dotazu
   my $sth_vpins=$dbh->prepare(q{
      insert into
         Vyroba_planovani.Vyrprikazy
         (
            Vyrprikazy.org,
            Vyrprikazy.zak,
            Vyrprikazy.kmint,
            Vyrprikazy.prik,
            Vyrprikazy.znprik,
            Vyrprikazy.str,
            Vyrprikazy.kszad,
            Vyrprikazy.ksvyk,
            Vyrprikazy.datvyk,
            Vyrprikazy.datzac,
            Vyrprikazy.datkon,
            Vyrprikazy.znmvlr,
            Vyrprikazy.sor,
            Vyrprikazy.datzapis,
            Vyrprikazy.uzivzapis
         )
      values
         (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
   });
   # ponizeni potreby o stav
   foreach my $zak (keys %potreba) {
      foreach my $kmint (keys %{$potreba{$zak}}) {
         my @str=sort keys %{$potreba{$zak}{$kmint}};
         foreach my $str (@str) {
            foreach my $termin (sort keys %{$potreba{$zak}{$kmint}{$str}}) {
               ## 000 a 999 je umely kmint a na nej se prikazy navystavuji - musim take likvidovat proto, abych zajistilt, ze na jeden kmint bude jen jedine stredisko (ve vyrobich prikazech stredisko neni v klici)
               ## podminkou "$str ne $str[-1]" zajistuji, generaci prikazu jen na jedine stredisko v ramci jednoho kmint - konkretne beru posledni str v abecede, coz by melo byt to spravne, jelikoz predpokladam, ze sklady RV jsou v abecede vzdy nize (a tedy ty diky teto podmince budou zlikvidovany) - schvalne zde nemam podminku na primo zda str je typ "sklrv", jelikoz bych pak sklrv sklady spravne musel ziskavat vzdy znovu a znovu k prislusnemu aktualnimu terminu
               ##if($kmint eq "000" or $kmint eq "999" or $str ne $str[-1]) {
               # ZMENA - podminky vyse jsem nahradil podminkou na to zda je kmint umely - asi to je cistejsi
               if($potreba{$zak}{$kmint}{$str}{$termin}{umely}) {
                  delete($potreba{$zak}{$kmint}{$str}{$termin});
               }
               else {
                  if($termin ne "Vyroba_stav") {
                     if($potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad}>=$potreba{$zak}{$kmint}{$str}{$termin}{kszad}) {
                        $potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad}-=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
                        delete($potreba{$zak}{$kmint}{$str}{$termin});
                     }
                     else {
                        $potreba{$zak}{$kmint}{$str}{$termin}{kszad}-=$potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad};
                        last;
                     }
                  }
               }
            }
            delete($potreba{$zak}{$kmint}{$str}{Vyroba_stav});
         }
      }
   }
   # aktualizace jiz existujicich VP
   if(!get_env("urgobj")) {
      my ($zak,$kmint,$str,$termin,@termin);
      $sth_vp->execute(get_env("org"));
      while(my $ref_vp=$sth_vp->fetchrow_hashref) {
         if($zak ne $$ref_vp{zak} or $kmint ne $$ref_vp{kmint} or $str ne $$ref_vp{str}) {
            $zak=$$ref_vp{zak};
            $kmint=$$ref_vp{kmint};
            $str=$$ref_vp{str};
            @termin=(sort keys %{$potreba{$zak}{$kmint}{$str}});
            $termin=shift(@termin);  # prvni polozka z @termin
         }
         # smycka na urovni jednoho VP
         my $poprve=1;
         my $pokrytovp=$$ref_vp{kspokryva};
         # pripad kdyz jde jiz o nepotrebny VP
         if(!defined($termin)) {
            $sth_vpupd->execute("9999-12-31","9999-12-31", get_env("org"),$zak,$kmint,$$ref_vp{prik});
         }
         # jinak zmen termin na nove vypocteny
         while(defined($termin)) {
            # uprav datum datum vp
            if($poprve) {
               my $datzac=My->date_adddecade($termin,-1*$potreba{$zak}{$kmint}{$str}{$termin}{pd});
               my $mytermin=$termin;
               my $mydatzac=$datzac;
               if($termin lt My->date_now) {
                  $mytermin=My->date_now;
               }
               if($datzac lt My->date_now) {
                  $mydatzac=My->date_now;
               }
               $sth_vpupd->execute($mydatzac,$mytermin, get_env("org"),$zak,$kmint,$$ref_vp{prik});
               $poprve=0;
            }
            # VP pokryva vice
            if($pokrytovp>$potreba{$zak}{$kmint}{$str}{$termin}{kszad}) {
               # okolik pokryva vice ?
               $pokrytovp-=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
               # likvidace terminu
               delete($potreba{$zak}{$kmint}{$str}{$termin});
               # vem dalsi termin
               $termin=shift(@termin);  # prvni polozka z @termin
               # pokud jiz neni dalsi termin - smycka skonci
            }
            # VP pokryva mene
            else {
               $potreba{$zak}{$kmint}{$str}{$termin}{kszad}-=$pokrytovp; # poniz termin
               # konec - vem dalsi vp
               last;
            }
         }
      }
   }
   # definice prvni cisla casti prikazu - vychazi z aktualniho data vypoctu - coz zajistuje vhodnou jedinecnost cisla vyrobniho prikazu v ramci roku (coz potrebuji v evidenci odpracovaneho vykonu, kde se operace vykazuji na konkretni prikaz)
   my $prik1=time2str("%Y%m",time);
   # tvorba novych VP
   foreach my $zak (keys %potreba) {
      foreach my $kmint (keys %{$potreba{$zak}}) {
         foreach my $str (keys %{$potreba{$zak}{$kmint}}) { # diky drivejsim filtracim by melo maximalne vracet jedine stredisko (tedy asi jich muze vratit vic, ale ty dalsi jiz nebudou mit zadny klic termin)
            # slouceni dle davky
            my %prikazydav;
            my ($termindav, $datdav);
            foreach my $termin (sort keys %{$potreba{$zak}{$kmint}{$str}}) {
               # termin nepada do davky
               if($datdav le $termin) { # opravdu "le" a ne "lt"?
                  if(My->date_now le $termin) {
                     $termindav=$termin;
                  }
                  else {
                     $termindav=My->date_now;
                  }
                  $datdav=My->date_adddecade($termindav,$potreba{$zak}{$kmint}{$str}{$termin}{dav});
                  $prikazydav{$termindav}{str}=$potreba{$zak}{$kmint}{$str}{$termin}{str};
                  $prikazydav{$termindav}{kszad}=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
                  $prikazydav{$termindav}{pd}=$potreba{$zak}{$kmint}{$str}{$termin}{pd};
                  $prikazydav{$termindav}{ch}=$potreba{$zak}{$kmint}{$str}{$termin}{ch};
               }
               # termin pada do davky
               else {
                  $prikazydav{$termindav}{kszad}+=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
               }
               # sortiment
               $prikazydav{$termindav}{sor}=Kusovnik->sor($potreba{$zak}{$kmint}{$str}{$termin}{sor},$prikazydav{$termindav}{sor});
               # znprik - v davce davam prednost vsem znprik pred znprik eq 8
               if(!defined($prikazydav{$termindav}{znprik}) or ($prikazydav{$termindav}{znprik} eq "8" and length($potreba{$zak}{$kmint}{$str}{$termin}{znprik}))) {
                  $prikazydav{$termindav}{znprik}=$potreba{$zak}{$kmint}{$str}{$termin}{znprik};
               }
            }
            # zaznam VP
            my $prik_porad;
            foreach my $termin (sort keys %prikazydav) {
               set_env("datum", $termin); ## ZMENA 2003-02-10
               my $datzac=My->date_adddecade($termin,-1*$prikazydav{$termin}{pd});
               if($datzac lt My->date_now) {
                  $datzac=My->date_now;
               }
               my $datomezeni;
               ## ZMENA 2003-02-10 - mrkam zda existuje predchozi kmint a pokud ne, jde o prvni kmint...
               my $info_normpred=Info->normativy($zak,$kmint,-1);
               # u prvniho kmint generuji prikazy vice do budoucna (tedy jeste v zavislosti na charakteristice)
               if(!$$info_normpred{_exist} and $prikazydav{$termin}{ch}=~/^.[0-2]$/) {
                  $datomezeni=My->period_addmonth(My->date_now,3)."-01";
               }
               else {
                  $datomezeni=My->period_addmonth(My->date_now,2)."-01";
               }
               if(int($prikazydav{$termin}{kszad})>0 and $datzac lt $datomezeni) {
                  # !!! Poznamka: znaky "prikazu", vraci obecny program dle toho jak dochazi k predavkam (pokud se nepletu tak pevny prikaz je tam, kde dochazi k predavce na jine stredisko)
                  # !!!           - to je v poradku a nechto tak, jelikoz to potrebujes pro jine ucely (zobrazovacky potreby a podobne)
                  # !!!           - ovsem zde u generace prikazu je treba takto vygenerovany znak "prikazu" zmenit aby plnil i jine ucely, treba:
                  # !!!             musi byt respektovano, ze musi byt pevny prikaz v pripade, ze na nej bude vystavena materialova vydejka (asi lepsi by mozna bylo pravidlo, kdyz se jedna o nejnizsi kmint na chvostu kusovnikoveho rozpadu),
                  # !!!             a musi respektovat, ze musi byt pevny, kdyz se na nej generuji listy rozpracovanosti (pak se totiz na nej vykazuje odpracovany vykon)
                  ## ZMENA 2003-03-07
                  # mechanicke dilny maji Listy rozpracovanosti, ke kazdemu prikazu. Listy rozpracovanosti maji smysl jen na pevny vyrobni prikaz - tedy u mechanickych dilen vzdy natvrdo valcuj znak prikazu z "8" na "0"
                  if($prikazydav{$termin}{znprik} eq "8") {
                     my $info_str=Info->str($prikazydav{$termin}{str});
                     if($$info_str{vyrtyp} eq "dilmech") {
                        $prikazydav{$termin}{znprik}="0";
                     }
                  }
                  ## ZMENA 2003-02-10
                  # pokud je znprik 8, tak jeste proverim zda nejde o prvni kmint na kte se vystavuje vydejka a pokud ano, tak ho natvrdo zmenim na znprik 0 - na kmint, kde se vystavuje vydejka MUSI byt pevni prikaz (jinak by se mohli generovat vydejky na neco na co jiz byly vydejky generovany)!!!
                  if($prikazydav{$termin}{znprik} eq "8") {
                     if(!$$info_normpred{_exist}) { # jde o prvni kmint?
                        my ($kmstrmat,$mat_info)=Vyroba->dodstr_mat($zak);
                        if(defined($kmstrmat)) {
                           $prikazydav{$termin}{znprik}="0";
                        }
                     }
                  }
                  if(!defined($prik_porad)) {
                     # zjisteni cisla VP
                     $prik_porad=$pkg->cisprik_porad($zak,$kmint,$prik1);
                  }
                  ++$prik_porad;
                  my $prik=$prik1 . $prik_porad;
                  # zaznam VP
                  $sth_vpins->execute(
                     get_env("org"),
                     $zak,
                     $kmint,
                     $prik,
                     $prikazydav{$termin}{znprik},
                     $prikazydav{$termin}{str},
                     $prikazydav{$termin}{kszad},
                     "0",
                     "0000-00-00",
                     $datzac,
                     $termin,
                     "02",
                     $prikazydav{$termin}{sor},
                     My->datetime_now,
                     My->remote_user
                  );
               }
            }
         }
      }
   }
   set_env("datum", My->date_now); ## ZMENA 2003-02-10
   # pokud slo o vypocet prikazu z urgetnich objednavek (ale i u "hlavniho" vypoctu), je treba ve vychozim souboru objednavek zrusit znacku urgentnosti
   Vyroba_planovani_objednavky->zrus_znak_urgence(get_env("org"));
}


# funkce zjistujici posledni cislo poradoveho cisla VP na danem kmint
sub cisprik_porad {
   my ($pkg_p, $zak,$kmint,$prik1)=@_;
   # dotaz na zjisteni posledniho poradoveho cisla VP na danem kmint
   my $sth_prik_porad=$dbh->prepare(q{
      select
         substring(Vyrprikazy.prik,7,2) as prik_porad
      from
         Vyroba_planovani.Vyrprikazy
      where
         Vyrprikazy.org=? and
         Vyrprikazy.zak=? and
         Vyrprikazy.kmint=? and
         substring(Vyrprikazy.prik,1,6)=? and
         substring(Vyrprikazy.prik,7,2)>10 and substring(Vyrprikazy.prik,7,2)<70
      order by
         substring(Vyrprikazy.prik,7,2) desc
      limit
         1
   });
   $sth_prik_porad->execute(get_env("org"),$zak,$kmint,$prik1);
   my $ref_prik_porad=$sth_prik_porad->fetchrow_hashref;
   $sth_prik_porad->finish;
   my $prik_porad=$$ref_prik_porad{prik_porad};
   if(!defined($prik_porad)) {
      $prik_porad="10";
   }
   return $prik_porad;
}


#======================================
#- hlavni funkce pocitajici a predpocitavajici potrebu zakazek a ukladajici vysledky
sub potrebazak_vypocet {
   my ($pkg_p, $objednavky,$potrebazaktable)=@_;
   $pkg->delvar_potreba;
   set_env("datum", My->date_now);
   #- Kdyz nejsou zadany nektere parametry je treba je nastavit
   if(!defined($potrebazaktable)) {
      $potrebazaktable="Vyroba_planovani.Potrebazak";
   }
   #- Pripad kdy pojedu z objednacek
   if(!defined($objednavky)) {
      #- Co maji strediska v prislusnem terminu odvest (a take Co jiz na stredisku je)
      my $sth_objednavky=$sth_objednavky_vse;
      $sth_objednavky->execute(get_env("org"));
      while(my $ref_objednavky=$sth_objednavky->fetchrow_hashref) {
         if($$ref_objednavky{termin} ge My->date_now) {
            set_env("datum", $$ref_objednavky{termin});
         }
         else {
            set_env("datum", My->date_now);
         }
         Kusovnik_norm->kusovnik_str(
            Kusovnik->ini({
               zak =>         $$ref_objednavky{zak},
               mnoz =>        $$ref_objednavky{ks},
               _funkce =>     "Kusovnik_norm->kusovnik_str",
               _funkce_str => undef, # predtim zde bylo: "$pkg->potreba_dopln_posledni"
               _funkce_str_pruchod => "$pkg->potreba_dopln",
               _str =>        $$ref_objednavky{strodv}, # u prvniho sledu se zapise do kmstr, z ktereho ja pak na konci beru zakaznikstr - pokud vubec nedojde k rozpadu, tedy v objednavkach org je zakazka co dana org vubec nedela zapisi do zakstr primo tohle, jinak kmstr posledniho kmint, kam az sem rozpadal (rozpadam jen na dane org)
               _odkmint =>    "999",
               termin =>      $$ref_objednavky{termin},
               sor =>         $$ref_objednavky{sor},
               zakaznikico => $$ref_objednavky{zakaznikico},
               _indmax =>     1,
               _potreba =>    1
            })
         );
      }
      $sth_objednavky->finish;
   }
   #- Pripad kdy jedu z umelych objednavek zadanych v hashi v parametru fce
   else {
      foreach my $zak (keys %{$objednavky}) {
         my $ref_objednavky=$$objednavky{$zak};
         if($$ref_objednavky{termin} ge My->date_now) {
            set_env("datum", $$ref_objednavky{termin});
         }
         else {
            set_env("datum", My->date_now);
         }
         Kusovnik_norm->kusovnik_str(
            Kusovnik->ini({
               zak =>         $$ref_objednavky{zak},
               mnoz =>        $$ref_objednavky{ks},
               _funkce =>     "Kusovnik_norm->kusovnik_str",
               _funkce_str => undef, # predtim zde bylo: "$pkg->potreba_dopln_posledni"
               _funkce_str_pruchod => "$pkg->potreba_dopln",
               _str =>        $$ref_objednavky{strodv}, # u prvniho sledu se zapise do kmstr, z ktereho ja pak na konci beru zakaznikstr - pokud vubec nedojde k rozpadu, tedy v objednavkach org je zakazka co dana org vubec nedela zapisi do zakstr primo tohle, jinak kmstr posledniho kmint, kam az sem rozpadal (rozpadam jen na dane org)
               _odkmint =>    "999",
               termin =>      $$ref_objednavky{termin},
               sor =>         $$ref_objednavky{sor},
               zakaznikico => $$ref_objednavky{zakaznikico},
               _indmax =>     1,
               _potreba =>    1
            })
         );
      }
   }
   #- Zapis vypoctene potreby
   set_env("datum", My->date_now);
   # Vymaz predchozi spoctene vysledky v pocitane org
   my $sth=$dbh->prepare(q{
      delete from
         } . $potrebazaktable . q{
      where
         org=?
   });
   $sth->execute(get_env("org"));
   # priprava dotazu na zaznam vypoctene potreby u zakazek
   my $sth_potrebazak=$dbh->prepare(q{
      insert into
         } . $potrebazaktable . q{
         (
            org,
            zak,
            kmint,
            str,
            termin,
            zn,
            potreba,
            chybi,
            plan,
            planbudouci,
            dodstr,
            mat,
            mj,
            mnoz,
            sklad,
            sor,
            zakaznikico,
            datzapis,
            uzivzapis
         )
      values
         (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
   });
   # ponizeni potreby o stav a zapis
   my @tabulky=("potreba","chybi","chybiVP","chybiMV");
   foreach my $zak (keys %potreba) {
      my $potrebazak;
      # zjisteni kolik delaj nesplnene vyrobni prikazy
      my %vyrprikazy_sum;
      $sth_vyrprikazy->execute(get_env("org"),$zak);
      while(my $ref_vyrprikazy=$sth_vyrprikazy->fetchrow_hashref) {
         set_env("datum", $$ref_vyrprikazy{datkon});
         $$potrebazak{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{$$ref_vyrprikazy{datkon}}{vyrprikazy}+=$$ref_vyrprikazy{ks};
         $vyrprikazy_sum{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}+=$$ref_vyrprikazy{ks};
         if(!length($potreba{$zak}{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{$$ref_vyrprikazy{datkon}}{str})) {
            $potreba{$zak}{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{$$ref_vyrprikazy{datkon}}{str}=$$ref_vyrprikazy{str};
            if(length($$ref_vyrprikazy{sor})>=9) { ## ZMENA 2002-09-18 - prebirane hodnoty z dopocteneho sortimentu na hpux nejsou uplne spolehlive a i drive nejak divne urceny sortiment mi muze negativne ovlivnovat sortiment dobre nove urceny
               $potreba{$zak}{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{$$ref_vyrprikazy{datkon}}{sor}=$$ref_vyrprikazy{sor};
            }
            my $info_zak=Info->zak($zak);
            $potreba{$zak}{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{$$ref_vyrprikazy{datkon}}{kmorg}=$$info_zak{kmorg};
         }
      }
      $sth_vyrprikazy->finish;
      # zjisteni kolik delaj nevidane mat vydejky
      my %vydejky_sum;
      $sth_vydejky->execute(get_env("org"),$zak);
      while(my $ref_vydejky=$sth_vydejky->fetchrow_hashref) {
         set_env("datum", $$ref_vydejky{datpoz});
         my ($kmstrmat,$mat_info)=Vyroba->dodstr_mat($zak);
         # predpokladam, ze Vydejky obsahuji jen vstupni material - natvrdo zde davam kmint "000"
         my $kmint="000";
         $$potrebazak{$kmint}{$kmstrmat}{$$ref_vydejky{datpoz}}{vydejky}+=$$ref_vydejky{ks};
         $vydejky_sum{$kmint}{$kmstrmat}+=$$ref_vydejky{ks};
         if(!length($potreba{$zak}{$kmint}{$kmstrmat}{$$ref_vydejky{datpoz}}{str})) {
            $potreba{$zak}{$kmint}{$kmstrmat}{$$ref_vydejky{datpoz}}{str}=$kmstrmat;
            if(length($$ref_vydejky{sor})>=9) { ## ZMENA 2002-09-18 - prebirane hodnoty z dopocteneho sortimentu na hpux nejsou uplne spolehlive a i drive nejak divne urceny sortiment mi muze negativne ovlivnovat sortiment dobre nove urceny
               $potreba{$zak}{$kmint}{$kmstrmat}{$$ref_vydejky{datpoz}}{sor}=$$ref_vydejky{sor};
            }
            my $info_zak=Info->zak($zak);
            $potreba{$zak}{$kmint}{$kmstrmat}{$$ref_vydejky{datpoz}}{kmorg}=$$info_zak{kmorg};
         }
      }
      $sth_vydejky->finish;
      set_env("datum", My->date_now);
      foreach my $kmint (keys %{$potreba{$zak}}) {
         foreach my $str (keys %{$potreba{$zak}{$kmint}}) {
            my %korekce=(
               potreba => 0,
               chybi =>   $potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad},
               chybiVP => $potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad}+$vyrprikazy_sum{$kmint}{$str},
               chybiMV => $potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad}+$vydejky_sum{$kmint}{$str}
            );
            my (%datdav,%termindav);
            my @terminy;
            foreach my $termin (sort keys %{$potreba{$zak}{$kmint}{$str}}) {
               if($termin ne "Vyroba_stav") {
                  push(@terminy,$termin);
               }
            }
            # znprikprednost - prednost
            my $znprikprednost;
            if($kmint eq "999") {
               $znprikprednost="8";
            }
            else {
               $znprikprednost="0";
            }
            # ponizeni potreby o stav a podobne (proste o korekci)
            foreach my $termin (@terminy) {
               # potreba, chybi chybiVP a chybiMV
               foreach my $tabulka (@tabulky) {
                  if($korekce{$tabulka}-$potreba{$zak}{$kmint}{$str}{$termin}{kszad}>=0) {
                     $korekce{$tabulka}-=$potreba{$zak}{$kmint}{$str}{$termin}{kszad};
                  }
                  else {
                     my $prirustek=$potreba{$zak}{$kmint}{$str}{$termin}{kszad}-$korekce{$tabulka};
                     $$potrebazak{$kmint}{$str}{$termin}{$tabulka}+=$prirustek;
                     # termin nepada do davky
                     if($datdav{$tabulka} le $termin) { ## POZNAMKA - misto "le" nemelo by tu byt "lt"
                        $datdav{$tabulka}=My->date_adddecade($termin,$potreba{$zak}{$kmint}{$str}{$termin}{dav});
                        $termindav{$tabulka}=$termin;
                     }
                     $$potrebazak{$kmint}{$str}{$termindav{$tabulka}}{$tabulka."_dav"}+=$prirustek;
                     $korekce{$tabulka}=0;
                  }
               }
            }
            # nove urceni promene @terminy
            my @terminy=sort keys %{$$potrebazak{$kmint}{$str}};
            # urceni sortimentu (i znprik) na urovni celeho kmint ("prumer" za vsecky terminy) - jelikoz i davkujes je to vhodnejsi
            my ($sor, $zakaznikico, $znprik);
            foreach my $termin (@terminy) {
               $sor=Kusovnik->sor($potreba{$zak}{$kmint}{$str}{$termin}{sor},$sor);
               $zakaznikico=Kusovnik->zakaznikico($potreba{$zak}{$kmint}{$str}{$termin}{zakaznikico},$zakaznikico);
               # znprik - davam prednost vsem znprik pred znprik eq 8 (tedy pokud nejde o kmint 999 - tam naopak davam prednost vsemu pred znprik 0 - to mi zajisti pozdeji filtraci 999 co jsou v objednavkach jako nahradni dily - sice to je skoda, ale je to lepsi nez to tam narvat i s kusama co jsou potreba na finaly)
               if(!defined($znprik) or ($znprik ne $znprikprednost and length($potreba{$zak}{$kmint}{$str}{$termin}{znprik}))) {
                  $znprik=$potreba{$zak}{$kmint}{$str}{$termin}{znprik};
               }
            }
            foreach my $termin (@terminy) {
               # poznamka - doplnujici udaje budu ziskavat na datum platnosti zjisteneho terminu (pokud jde vsak o minulost tak na aktualni datum)
               if($termin ge My->date_now) {
                  set_env("datum", $termin);
               }
               else {
                  set_env("datum", My->date_now);
               }
               # potreba
               my $potreba=sprintf("%.0f",$$potrebazak{$kmint}{$str}{$termin}{potreba});
               # chybi
               my $chybi=sprintf("%.0f",$$potrebazak{$kmint}{$str}{$termin}{chybi});
               # nezaznamenavam potrebu u kazde sestavy, ale jen tam, kde by pri odvadeni byl zastaven rozpad a tedy menil se stav
               # poznamka: $potreba{$zak}{$kmint}{$str}{$termin}{znprik} jsem na urovni kmint nesjednotil
               if($kmint ne "000") {
                  ## ZMENA 2002-11-25, drive zde byla podminka: if($znprik eq "0" or $znprik eq "2" or $znprik eq "9" or $kmint ne "999") {
                  ## - drivejsi podmince rozumim, ze jsi nechtel zaznamenat kmint 999 se znprik 8 - coz se mi zacalo jevit potrebne pro fci "Poteba zakzek a rozpracovanost"
                  if(1) {
                     if($znprik eq "0" and $kmint ne "999") {
                        $znprik="1"; # kvuli pozdejsimu lepsimu razeni...
                     }
                     # dodstr - nejsem si jist, ale melo by to byt kmstr z posledniho kmint u org v ktere bude objednavka zapsana
                     my $dodstr=$potreba{$zak}{$kmint}{$str}{$termin}{dodstr};
                     # plan
                     my $plan=sprintf("%.0f",$$potrebazak{$kmint}{$str}{$termin}{vyrprikazy});
                     # planbudouci
                     my $planbudouci=sprintf("%.0f",$$potrebazak{$kmint}{$str}{$termin}{chybiVP_dav});
                     $sth_potrebazak->execute(
                        get_env("org"),
                        $zak,
                        $kmint,
                        $str,
                        $termin,
                        "$znprik",
                        $potreba,
                        $chybi,
                        $plan,
                        $planbudouci,
                        "$dodstr",
                        "",
                        "",
                        0,
                        "",
                        $sor,
                        "$zakaznikico",
                        My->datetime_now,
                        My->remote_user
                     );
                  }
               }
               else {
                  # ziskani informaci o vstupnim materialu
                  my $Edatum=get_env("datum");
                  set_env("datum",$termin);
                  my $mat_info=Vyroba->mat_info($zak);
                  set_env("datum",$Edatum);
                  # dodstr
                  my $dodstr="";
                  # plan
                  my $plan=sprintf("%.0f",$$potrebazak{$kmint}{$str}{$termin}{vydejky});
                  # planbudouci
                  my $planbudouci=sprintf("%.0f",$$potrebazak{$kmint}{$str}{$termin}{chybiMV_dav});
                  # pokud nebude nalezen material v materialove norme a k nemu sklad, pak potrebu materialu ignoruji
                  if(length($$mat_info{sklad})) {
                     # mnoz
                     my $mnoz=Conversion->mj($$mat_info{mnoz},$$mat_info{mj},$$mat_info{mjsklad});
                     # zn
                     my $zn="0";
                     # pokud byly mj nepreveditelne jde o chybu => zapis mno=0 a zn="E"
                     if(!defined($mnoz)) {
                        $mnoz=0;
                        $zn="E";
                     }
                     $sth_potrebazak->execute(
                        get_env("org"),
                        $zak,
                        $kmint,
                        $str,
                        $termin,
                        $zn,
                        $potreba,
                        $chybi,
                        $plan,
                        $planbudouci,
                        $dodstr,
                        $$mat_info{mat},
                        $$mat_info{mjsklad},
                        $mnoz,
                        $$mat_info{sklad},
                        $sor,
                        "$zakaznikico",
                        My->datetime_now,
                        My->remote_user
                     );
                  }
               }
            }
         }
      }
   }
}


#======================================
#- funkce zjistujici potrebu zakazky
# funkce je uzita napriklad programem Potreba dane zakazky a take Potreba materialu
# !!! POZOR z duvodu rychlosti pocita potrebu na kusovnik platny v get_env("datum") !!!
sub potrebazak {
   my ($pkg_p, $zak,$druhobd,$vychdatum,$indexmax,$kody)=@_;
   $pkg->delvar_potreba;
   # u skutecneho vypoctu VP menim datum dle terminu v objednavkach - pro optimalizaci na rychlost jsem pristoupil k zjednoduseni (pocitam jen jednu zakazku z objednavek) a uvazuji $vychdatum, po celou dobu vypoctu potreby
   # - datum je nastaveno v hlavnim programu, z ktereho je tato fce volana
   # Vytvoreni pracovniho kusovniku - z inverzniho kusovniku
   my $kusovniktable="test.Kusovnik";
   Kusovnik->invkusovnik_temp(
      Kusovnik->invini({
         zak =>         $zak,
         mnoz =>        1,
         _funkce =>     "$pkg->invkusovnik_write",
         _temptable =>  $kusovniktable
      })
   );
   # Priprava dotazu - mrknuti do objednavek zda tam je dana zakazka
   my $sth_obj=$dbh->prepare(q{
      select
         Objednavky.zak,
         Objednavky.strodv
      from
         Vyroba_planovani.Objednavky
      where
         Objednavky.org=? and
         Objednavky.zak=? and
         Objednavky.kszad>Objednavky.ksvyk
      limit
         1
   });
   # ziskani seznamu zakazek, ktere mohou byt v objednavkach a ktere maji v kusovniku zkoumanou zakazku
   my $terminpom="2000-01-01";
   my @zakobj;
   push(@zakobj,$zak); # pridani samotne zakazky
   my $sth_kus=$dbh->prepare(q{
      select distinct
         zakv
      from
         } . $kusovniktable . q{
   });
   $sth_kus->execute;
   while(my $ref_kus=$sth_kus->fetchrow_hashref) { # pridani pripadnych zakazek vyssich
      push(@zakobj,$$ref_kus{zakv});
   }
   $sth_kus->finish;
   # vypocet pro jednotlive zakazky, ktere jsou v objedavkach
   foreach my $zakv (@zakobj) {
      $sth_obj->execute(get_env("org"),$zakv);
      while(my $ref_obj=$sth_obj->fetchrow_hashref) { # vraci vzdy jen jeden zaznam...
         Kusovnik_norm->kusovnik_str(
            Kusovnik->ini({
               zak =>         $zakv,
               mnoz =>        1,
               _table =>      $kusovniktable,
               _funkce =>     "Kusovnik_norm->kusovnik_str",
               _funkce_str => undef, # predtim zde bylo: "$pkg->potreba_dopln_posledni"
               _funkce_str_pruchod => "$pkg->potreba_dopln",
               _str =>        $$ref_obj{strodv},
               _odkmint =>    "999",
               termin =>      $terminpom,
               _indmax =>     1,
               _bezpd =>      $$kody{_bezpd},
               _bezzm =>      $$kody{_bezzm},
               _potreba =>    1,
               _potrebazak => 1
            })
         );
      }
      $sth_obj->finish;
   }
   #- Uprava vypoctu potreby na skutecne objednavky (zmenit terminy a kusy)
   my %potrebazakskut=();
   my %umely; # zde si ulozis informaci zda je normativ umely
   # Priprava dotazu - mrknuti do objednavek zda tam je dana zakazka
   my $sth_obj=$dbh->prepare(q{
      select
         Objednavky.termin,
         (Objednavky.kszad-Objednavky.ksvyk) as ks
      from
         Vyroba_planovani.Objednavky
      where
         Objednavky.org=? and
         Objednavky.zak=? and
         Objednavky.kszad>Objednavky.ksvyk
   });
   my $potrebazakobj={}; # !!!! POZOR ty {} jsou velmi dulezite, je tim receno, ze $potrebazakobj je pointer na hash! pokud by tomu tak nebylo a ve smicce nize bych nedosel k radku $$potrebazakobj..= tak by se ztratili pripadne hodnoty ziskane v "URCENI stavu v sestavach" (algoritmus uplne na konci fce)
   foreach my $zakv (@zakobj) {
      $sth_obj->execute(get_env("org"),$zakv);
      while(my $ref_obj=$sth_obj->fetchrow_hashref) {
         ## Jelikoz v Normativech sou dekady je dobre postavit i posun oproti pevne zvolenemu datu na dekadach a ne na dnech - jinak diky tomu, ze kazdy mesic je jinak dlouhy dochazelo na hranach mesicu ke spadnuti vlevo ci vpravo do jineho mesice...
         ## - pri pripadnem prechodu na planovani v jinych jednotkach (treba dnech) to bude dobre i zde predelat
         ##my $terminrozdildni=My->date_subtract($$ref_obj{termin},$terminpom);
         my $terminrozdildekad=My->date_to_decade($$ref_obj{termin})-My->date_to_decade($terminpom);
         my $zakkey=$zakv."-".$zak;
         my ($kmint_last,$str_last);
         foreach my $kmint (sort keys %{$potreba{$zakkey}}) {
            foreach my $str (sort keys %{$potreba{$zakkey}{$kmint}}) {
               foreach my $termin (sort keys %{$potreba{$zakkey}{$kmint}{$str}}) {
                  ##my $terminnew=My->date_addday($termin,$terminrozdildni);
                  my $terminnew=My->date_adddecade($termin,$terminrozdildekad);
                  my $kszad=$potreba{$zakkey}{$kmint}{$str}{$termin}{kszad};
                  $potrebazakskut{$kmint}{$str}{$terminnew}{kszad}+=$kszad*$$ref_obj{ks};
                  my $dav=$potreba{$zakkey}{$kmint}{$str}{$termin}{dav};
                  $potrebazakskut{$kmint}{$str}{$terminnew}{dav}=$dav;
                  # jen uschovicka informace zda je kmint umely
                  $umely{$kmint}{$str}=$potreba{$zakkey}{$kmint}{$str}{$termin}{umely};
               }
               $str_last=$str;
            }
            $kmint_last=$kmint;
         }
         # jaka je potreba na splneni prislusne zakazky v objednavkach (staveno na terminy objednavek - tedy bez pd - tedy mysleno kdy ty soucasti vlastne budu jiz posilat zakaznikovi)
         if($$kody{_zobobj} and $kmint_last eq "999") {
            foreach my $termin (sort keys %{$potreba{$zakkey}{$kmint_last}{$str_last}}) {
               my $index=My->period_index($$ref_obj{termin},$druhobd,$vychdatum,$indexmax);
               my $kszadbezzm=$potreba{$zakkey}{$kmint_last}{$str_last}{$termin}{kszadbezzm};
               $$potrebazakobj{$zakv}{potreba}[$index]+=$kszadbezzm*$$ref_obj{ks};
            }
         }
      }
      $sth_obj->finish;
   }
   # zapis do promene $potrebazak
   my $potrebazak;
   my @tabulky=("potreba","chybi");
   my $Edatum=get_env("datum");
   # zapis do promene: vyrprikazy
   if($$kody{_chybiVP}) {
      push(@tabulky,"chybiVP");
      $sth_vyrprikazy->execute(get_env("org"),$zak);
      while(my $ref_vyrprikazy=$sth_vyrprikazy->fetchrow_hashref) {
         set_env("datum", $$ref_vyrprikazy{datkon});
         my $index=My->period_index($$ref_vyrprikazy{datkon},$druhobd,$vychdatum,$indexmax);
         $$potrebazak{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{vyrprikazy}[$index]+=$$ref_vyrprikazy{ks};
         $$potrebazak{$$ref_vyrprikazy{kmint}}{$$ref_vyrprikazy{str}}{vyrprikazy_sum}+=$$ref_vyrprikazy{ks};
      }
      $sth_vyrprikazy->finish;
   }
   # zapis do promene: vydejky
   if($$kody{_chybiMV}) {
      push(@tabulky,"chybiMV");
      $sth_vydejky->execute(get_env("org"),$zak);
      while(my $ref_vydejky=$sth_vydejky->fetchrow_hashref) {
         set_env("datum", $$ref_vydejky{datpoz});
         my ($kmstrmat,$mat_info)=Vyroba->dodstr_mat($zak);
         # predpokladam, ze Vydejky obsahuji jen vstupni material - natvrdo zde davam kmint "000"
         my $kmint="000";
         my $index=My->period_index($$ref_vydejky{datpoz},$druhobd,$vychdatum,$indexmax);
         $$potrebazak{$kmint}{$kmstrmat}{vydejky}[$index]+=$$ref_vydejky{ks};
         $$potrebazak{$kmint}{$kmstrmat}{vydejky_sum}+=$$ref_vydejky{ks};
      }
      $sth_vydejky->finish;
   }
   set_env("datum", $Edatum);
   # zapis do promene: stav a potreba (z objednavek), chybi, chybiVP a chybiMV
   foreach my $kmint (keys %potrebazakskut) {
      foreach my $str (keys %{$potrebazakskut{$kmint}}) {
         # stav
         $$potrebazak{$kmint}{$str}{stav}=$potreba{$zak}{$kmint}{$str}{Vyroba_stav}{kszad}; # pozn: v klici je spravne $zak a ne $zakkey, jelikoz stav se vede vzdy na $zak (pozn2: nevi proc, ale mel jsi tu "+=")
         my %korekce=(
            potreba => 0,
            chybi =>   $$potrebazak{$kmint}{$str}{stav},
            chybiVP => $$potrebazak{$kmint}{$str}{stav}+$$potrebazak{$kmint}{$str}{vyrprikazy_sum},
            chybiMV => $$potrebazak{$kmint}{$str}{stav}+$$potrebazak{$kmint}{$str}{vydejky_sum}
         );
         my (%datdav,%indexdav);
         foreach my $termin (sort keys %{$potrebazakskut{$kmint}{$str}}) {
            # zjisteni indexu daneho $termin
            my $index=My->period_index($termin,$druhobd,$vychdatum,$indexmax);
            # potreba, chybi, chybiVP, chybiMV (i davkovane)
            foreach my $tabulka (@tabulky) {
               # u umelych kmint tohle nepocitam (v souladu s podminkou, ze na umele kmint nemaji byt generovany vyrobni prikazy)
               if($tabulka eq "chybiVP" and $umely{$kmint}{$str}) {
                  last;
               }
               if($korekce{$tabulka}-$potrebazakskut{$kmint}{$str}{$termin}{kszad}>=0) {
                  $korekce{$tabulka}-=$potrebazakskut{$kmint}{$str}{$termin}{kszad};
               }
               else {
                  my $prirustek=$potrebazakskut{$kmint}{$str}{$termin}{kszad}-$korekce{$tabulka};
                  $$potrebazak{$kmint}{$str}{$tabulka}[$index]+=$prirustek;
                  # termin nepada do davky => zmena $datdav{$tabulka} $indexdav{$tabulka} - priprava pro davkovane zapisy
                  if($datdav{$tabulka} le $termin) { ## POZNAMKA - misto "le" nemelo by tu byt "lt"
                     $datdav{$tabulka}=My->date_adddecade($termin,$potrebazakskut{$kmint}{$str}{$termin}{dav});
                     $indexdav{$tabulka}=$index;
                  }
                  $$potrebazak{$kmint}{$str}{$tabulka."_dav"}[$indexdav{$tabulka}]+=$prirustek;
                  $korekce{$tabulka}=0;
               }
            }
         }
      }
   }
   # URCENI stavu v sestavach - jen kdyz to chci videt (at to nezpomaluje) a ulozeni do $potrebazakobj
   if($$kody{_zobobj}) {
      $pkg->invkusovnik_stav(
         Kusovnik->invini({
            zak =>            $zak,
            mnoz =>           1,
            _funkce =>        "$pkg->invkusovnik_stav",
            _potrebazakobj => $potrebazakobj
         })
      );
   }
   Kusovnik->invkusovnik_drop($kusovniktable);
   return ($potrebazak,$potrebazakobj);
}
# pomocna fce zapisujici pomocny kusovnik (tedy urcuje co za vaby se ma zapisovat a ridi zastaveni rozpadu)
sub invkusovnik_write {
   my ($pkg_p, $vazba)=@_;
   my $ref_zak=Info->zak($$vazba{zakv});
   if($$ref_zak{kmorg} eq get_env("org") or $$vazba{sled}==0) {
      Kusovnik->invkusovnik_write($vazba);
   }
}
# pomocna funkce pro zjistovani stavu na zakazkach vyssich
# jiste zjednoduseni - respektive jiny pohled - nejdu zpetne po strediscich a tedy zjistuji stav zakazek naprosto na vsech strediscich a kmint (tedy u zakazky samotne jen na kmint 999 a 998)
sub invkusovnik_stav {
   my ($pkg_p, $vazba)=@_;
   my $ref_zak=Info->zak($$vazba{zakv});
   if($$ref_zak{kmorg} eq get_env("org") or $$vazba{sled}==0) {
      my $potrebazakobj=$$vazba{_potrebazakobj};
      my $sth;
      if($$vazba{zakv} eq $$vazba{zak}) {
         $sth=$sth_stav_998_999;
      }
      else {
         $sth=$sth_stav_vse;
      }
      $sth->execute(get_env("org"),$$vazba{zakv});
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      if($$ref{stav}!=0) {
         $$potrebazakobj{$$vazba{zakv}}{stav}=$$vazba{mnozc}*$$ref{stav};
      }
      Kusovnik->invkusovnik($vazba);
   }
}


 
#======================================
sub potreba_dopln {
   my ($pkg_p, $vazba)=@_;
   #- navyseni poctu kusu o zmetky
   my $kszad;
   if(!$$vazba{_bezzm}) {
      # radek nize je jiz zbytecny navysovani o proczm resim jiz na urovni Kusovnik_norm.pm a to v promene $$vazba{mnozczm} samotna promene $$vazba{mnozc} zustava netknuta
      #$$vazba{mnozc}+=$$vazba{mnozc}*$$vazba{proczm}*0.01;
      $kszad=$$vazba{mnozczm};
      $$vazba{Vyroba_stav}*=1+$$vazba{proczm}*0.01;
   }
   else {
      $kszad=$$vazba{mnozc};
   }
   ## ZMENA 2002-11-04 - pri poklesu o kusovnikovy sled niz musis navysit stav o prislusny pocet kusu, kolikrat aktualni dil vstupuje do sestavy
   ## -> presunuto primo do Kusovnik_norm
   #- Potreba
   my $zakkey=$pkg->zakkey($vazba);
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{kszad}+=$kszad;
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{kszadbezzm}+=$$vazba{mnozc};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{kmorg}=$$vazba{kmorg};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{str}=$$vazba{kmstr};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{dodstr}=$$vazba{dodstr};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{prejstr}=$$vazba{prejstr};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{dav}=$$vazba{dav};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{pd}=$$vazba{pd};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{umely}=$$vazba{umely};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{ch}=$$vazba{ch};
   $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{znprik}=$$vazba{znprik};
   if(defined($$vazba{sor})) { # pri vypoctu vyrobnich prikazu nyni urcujes i sortiment
      $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{sor}=Kusovnik->sor($$vazba{sor},$potreba{$zakkey}{$$vazba{kmint}}{$$vazba{termin}}{sor});
   }
   if(defined($$vazba{zakaznikico})) {
      $potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{zakaznikico}=Kusovnik->zakaznikico($$vazba{zakaznikico},$potreba{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin}}{zakaznikico});
   }
   #- Stav
   # nema smysl zjistovat jiz stav pokud jsem ho jiz predtim zjistil a dokonce i pricetl
   if(!defined($potreba{$$vazba{zakn}}{$$vazba{kmint}}{$$vazba{kmstr}}{Vyroba_stav}{kszad})) {
      # navyseni poctu kusu o stav; Pozn: vyrobni prikaz rika kolik ma byt odvedeno ks z danneho kmint - proto samotny stav na zkoumanem kmint nezapocitavam, jelikoz to tam lezi, ale jeste to nebylo odvedeno
      if($$vazba{kmint} ne "999") {
         # nove si hraju si na strediska...
         $potreba{$$vazba{zakn}}{$$vazba{kmint}}{$$vazba{kmstr}}{Vyroba_stav}{kszad}+=$$vazba{Vyroba_stav};
         my $info_stav=Info->vyroba_stav($$vazba{zakn},$$vazba{kmint},$$vazba{kmstr});
         if($$info_stav{stav}>0) {
            $$vazba{Vyroba_stav}+=$$info_stav{stav};
         }
      }
      else {
         # nove si hraju si na strediska... ale asi zapominam na kmint 998 coz bych mel mozna jeste doplnit...
         $potreba{$$vazba{zakn}}{$$vazba{kmint}}{$$vazba{kmstr}}{Vyroba_stav}{kszad}+=$$vazba{Vyroba_stav};
         my $info_stav=Info->vyroba_stav($$vazba{zakn},$$vazba{kmint},$$vazba{kmstr});
         if($$info_stav{stav}>0) {
            $$vazba{Vyroba_stav}+=$$info_stav{stav};
         }
         # reseni kolem stavu na 998 - sem proste jdu, kdyz resim situaci kolem 999 - zde si nehraji na strediska, coz je ok
         $sth_stav_998->execute(get_env("org"),$$vazba{zakn});
         my $ref_stav_998=$sth_stav_998->fetchrow_hashref;
         $sth_stav_998->finish;
         $$vazba{Vyroba_stav}+=$$ref_stav_998{stav};
      }
   }
   else {
      $potreba{$$vazba{zakn}}{$$vazba{kmint}}{$$vazba{kmstr}}{Vyroba_stav}{kszad}+=$$vazba{Vyroba_stav};
      # !!! $$vazba{Vyroba_stav} neni mozne jiz navysovat - jiz tak bylo nekdy ucineno (v jinem rozpadu ci sledu)
   }
   # pamatovak terminu z posledniho kmint - kvuli objednavky_dopln a monvydejky_dopln, ale mozna je to zbytecne, jelikoz tam to stejne vzdy bude koncit na imaginarni kmint 999, kde pd neni, ale mozna se pletu
   $$vazba{termin_posledni}=$$vazba{termin};
   #- ponizeni terminu o pd
   if(!$$vazba{_bezpd}) {
      $$vazba{termin}=My->date_adddecade($$vazba{termin},-1*$$vazba{pd});
   }
}

# jen u vypoctu objednavek - jde to sem, kdyz jde o nejnizsi kmint ci pokud je zak z jine org nebo pokud se jiz nerozpadla
sub objednavky_dopln {
   my ($pkg_p, $vazba,$posledni)=@_;
   if($posledni) {
      # zakazka je z jine org nez je aktualni (podminka length($$vazba{kmorg}) zajistuje, ze ignoruji zakazky, ktere nebyly nalezeny v ciselniku zakazek a tedy jejich kmorg je prazdne)
      if(length($$vazba{kmorg}) and get_env("org") ne $$vazba{kmorg} and $$vazba{kmorg} ne "0") {
         my $objednavky=$$vazba{_objednavky};
         # urcovani sortimentu a vlastne pamatovak klice, pomoci ktereho pak ziskam mnozstvi z promene %potreba
         my $zakkey=$pkg->zakkey($vazba);
         $$objednavky{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin_posledni}}{sor}=Kusovnik->sor($$vazba{zak},$$objednavky{$zakkey}{$$vazba{kmint}}{$$vazba{kmstr}}{$$vazba{termin_posledni}}{sor});
      }
   }
}

# jen pomocny dotaz na zjistenu "zakkey"
sub zakkey {
   my ($pkg_p, $vazba)=@_;
   my $zakkey;
   if($$vazba{_potrebazak}) {
      $zakkey=$$vazba{zak}."-".$$vazba{zakn};
   }
   else {
      $zakkey=$$vazba{zakn};
   }
   return $zakkey;
}

return 1;

