package Vyroba_priprava_kopie;

# !!! Vsechny kopirovaci fce by to casem chtelo vylepsit     !!!
# !!! na styl podobny jako je ve fci Akt. vyrobniho postupu, !!!
# !!! pripadne na styl podobny fci Import nzv nad z     !!!
# !!! externho souboru (org 5).                             !!!

my $pkg="Vyroba_priprava_kopie";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;

#==== Globalni promena tohohle balicku

#==== Napojeni na DB
my $dbh=My->dbh;


#- funkce kopiruje kusovnik ze vzorove zakazky na cilovou
sub kusovnik {
   my ($pkg_p, $zakvzor,$zakcil)=@_;
   # promena pro ukladani hlasky v HTML
   my $docxhtml=XML::LibXML::Document->new;
   my $xhtmlO=MyXML->new("xhtml");
   $docxhtml->setDocumentElement($xhtmlO);
   #=== Kontroly
   my $OK=1;
   my $info_zakcil=Info->zak($zakcil);
   # Cilova zakazka musi mit vykrorg shodne s get_env("org")
   if($$info_zakcil{vykrorg} ne get_env("org")) {
      $OK=0;
      $xhtmlO->aT("p",{style=>"color:red;"},"Koprovn kusovnku neme probhnout, jeliko clov zakzka nem jako vkresovou organizaci org " . get_env("org") . ".");
   }
   #=== Kopirovani
   if($OK) {
      my $table="Zakazky.Kusovnik";
      my $sth=$dbh->prepare(q{
         select
            Kusovnik.zakn
         from
            Zakazky.Kusovnik
         where
            Kusovnik.zakv=? and
            Kusovnik.platod<=? and
            Kusovnik.platdo>=?
      });
      # * Uzavreni platnosti vsech existujicich zaznamu v danem case u $zakcil
      # nacteni vsech dalsich klicu u $zakcil
      my $prikeys;
      $sth->execute($zakcil,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{zakn}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $zakn (sort keys %{$prikeys}) {
         my $info_value=Info->kusovnik($zakcil,$zakn);
         # zaznam plati od zacatku aktualni dekady => "zrus ho"
         if($$info_value{platod} eq get_env("datum")) {
            Write->delete({
               _table => $table,
               _key_zakv => $zakcil,
               _key_zakn => $zakn,
               _key_platod => $$info_value{platod}
            });
         }
         # zaznam plati jiz od drivejska => "uzavri platnost"
         else {
            Write->update({
               _table => $table,
               _key_zakv => $zakcil,
               _key_zakn => $zakn,
               _key_platod => $$info_value{platod},
               platdo => My->date_addday(get_env("datum"),-1),
               _bezdatzapis => 1
            });
         }
      }
      # * Nacitani zaznamu ze $zakvzor a zapis do $zakcil
      # nacteni vsech dalsich klicu u $zakvzor
      my $prikeys;
      $sth->execute($zakvzor,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{zakn}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $zakn (sort keys %{$prikeys}) {
         my $info_value=Info->kusovnik($zakvzor,$zakn);
         # priprava na zapis noveho zaznamu
         my $write={
            _table => $table,
            zakv => $zakcil,
            zakn => $zakn,
            platod => get_env("datum"),
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         };
         # dalsi hodnoty preber z hodnot u $zakvzor
         foreach my $col (Write->show_tablecols($table)) {
            if(!defined($$write{$col})) {
               $$write{$col}=$$info_value{$col};
            }
         }
         my $info_value_future=Info->kusovnik($zakcil,$zakn,{future=>1});
         # zaznam neexistuje ani v budoucnosti
         if(!($$info_value_future{_exist})) {
            $$write{platdo}="9999-12-31";
         }
         # zaznam existuje v budoucnosti
         else {
            $$write{platdo}=My->date_addday($$info_value_future{platod},-1);
         }
         # zapis noveho zaznamu
         Write->insert($write);
      }
      # oznameni o probehlem kopirovani
      $xhtmlO->aT("p",{style=>"color:green;"},"Kusovnk byl zkoprovn.");
   }
   # definice status
   my $status={
      status => $OK,
      hlaska => $xhtmlO
   };
   return $status;
}

#- funkce kopiruje materialovou normu ze vzorove zakazky na cilovou
sub material_norma {
   my ($pkg_p, $zakvzor,$zakcil)=@_;
   # promena pro ukladani hlasky v HTML
   my $docxhtml=XML::LibXML::Document->new;
   my $xhtmlO=MyXML->new("xhtml");
   $docxhtml->setDocumentElement($xhtmlO);
   #=== Kontroly
   my $OK=1;
   my $info_zakcil=Info->zak($zakcil);
   # Cilova zakazka musi mit kmorg shodne s get_env("org")
   if($$info_zakcil{kmorg} ne get_env("org")) {
      $OK=0;
      $xhtmlO->aT("p",{style=>"color:red;"},"Koprovn materilov normy neme probhnout, jeliko clov zakzka nem jako kmenovou organizaci org " . get_env("org") . ".");
   }
   #=== Kopirovani
   if($OK) {
      my $table="Vyroba_priprava.Material_norma";
      my $sth=$dbh->prepare(q{
         select
            Material_norma.oper,
            Material_norma.mat
         from
            Vyroba_priprava.Material_norma
         where
            Material_norma.zak=? and
            Material_norma.platod<=? and
            Material_norma.platdo>=?
      });
      # * Uzavreni platnosti vsech existujicich zaznamu v danem case u $zakcil
      # nacteni vsech dalsich klicu u $zakcil
      my $prikeys;
      $sth->execute($zakcil,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}{$$ref{mat}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         foreach my $mat (sort keys %{$$prikeys{$oper}}) {
            my $info_value=Info->material_norma($zakcil,$oper,$mat);
            # zaznam plati od zacatku aktualni dekady => "zrus ho"
            if($$info_value{platod} eq get_env("datum")) {
               Write->delete({
                  _table => $table,
                  _key_zak => $zakcil,
                  _key_oper => $oper,
                  _key_mat => $mat,
                  _key_platod => $$info_value{platod}
               });
            }
            # zaznam plati jiz od drivejska => "uzavri platnost"
            else {
               Write->update({
                  _table => $table,
                  _key_zak => $zakcil,
                  _key_oper => $oper,
                  _key_mat => $mat,
                  _key_platod => $$info_value{platod},
                  platdo => My->date_addday(get_env("datum"),-1),
                  _bezdatzapis => 1
               });
            }
         }
      }
      # * Nacitani zaznamu ze $zakvzor a zapis do $zakcil
      # nacteni vsech dalsich klicu u $zakvzor
      my $prikeys;
      $sth->execute($zakvzor,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}{$$ref{mat}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         foreach my $mat (sort keys %{$$prikeys{$oper}}) {
            my $info_value=Info->material_norma($zakvzor,$oper,$mat);
            # priprava na zapis noveho zaznamu
            my $write={
               _table => $table,
               zak => $zakcil,
               oper => $oper,
               mat => $mat,
               platod => get_env("datum"),
               datzapis => My->datetime_now,
               uzivzapis => My->remote_user
            };
            # dalsi hodnoty preber z hodnot u $zakvzor
            foreach my $col (Write->show_tablecols($table)) {
               if(!defined($$write{$col})) {
                  $$write{$col}=$$info_value{$col};
               }
            }
            my $info_value_future=Info->material_norma($zakcil,$oper,$mat,{future=>1});
            # zaznam neexistuje ani v budoucnosti
            if(!($$info_value_future{_exist})) {
               $$write{platdo}="9999-12-31";
            }
            # zaznam existuje v budoucnosti
            else {
               $$write{platdo}=My->date_addday($$info_value_future{platod},-1);
            }
            # zapis noveho zaznamu
            Write->insert($write);
         }
      }
      # oznameni o probehlem kopirovani
      $xhtmlO->aT("p",{style=>"color:green;"},"Materilov norma byla zkoprovna.");
   }
   # definice status
   my $status={
      status => $OK,
      hlaska => $xhtmlO
   };
   return $status;
}

#- funkce kopiruje normu naradi ze vzorove zakazky na cilovou
sub naradi_norma {
   my ($pkg_p, $zakvzor,$zakcil)=@_;
   # promena pro ukladani hlasky v HTML
   my $docxhtml=XML::LibXML::Document->new;
   my $xhtmlO=MyXML->new("xhtml");
   $docxhtml->setDocumentElement($xhtmlO);
   #=== Kontroly
   my $OK=1;
   my $info_zakcil=Info->zak($zakcil);
   # Cilova zakazka musi mit kmorg shodne s get_env("org")
   if($$info_zakcil{kmorg} ne get_env("org")) {
      $OK=0;
      $xhtmlO->aT("p",{style=>"color:red;"},"Koprovn normy nad neme probhnout, jeliko clov zakzka nem jako kmenovou organizaci org " . get_env("org") . ".");
   }
   #=== Kopirovani
   if($OK) {
      my $table="Vyroba_priprava.Naradi_norma";
      my $sth=$dbh->prepare(q{
         select
            Naradi_norma.oper,
            Naradi_norma.nar
         from
            Vyroba_priprava.Naradi_norma
         where
            Naradi_norma.zak=? and
            Naradi_norma.platod<=? and
            Naradi_norma.platdo>=?
      });
      # * Uzavreni platnosti vsech existujicich zaznamu v danem case u $zakcil
      # nacteni vsech dalsich klicu u $zakcil
      my $prikeys;
      $sth->execute($zakcil,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}{$$ref{nar}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         foreach my $nar (sort keys %{$$prikeys{$oper}}) {
            my $info_value=Info->naradi_norma($zakcil,$oper,$nar);
            # zaznam plati od zacatku aktualni dekady => "zrus ho"
            if($$info_value{platod} eq get_env("datum")) {
               Write->delete({
                  _table => $table,
                  _key_zak => $zakcil,
                  _key_oper => $oper,
                  _key_nar => $nar,
                  _key_platod => $$info_value{platod}
               });
            }
            # zaznam plati jiz od drivejska => "uzavri platnost"
            else {
               Write->update({
                  _table => $table,
                  _key_zak => $zakcil,
                  _key_oper => $oper,
                  _key_nar => $nar,
                  _key_platod => $$info_value{platod},
                  platdo => My->date_addday(get_env("datum"),-1),
                  _bezdatzapis => 1
               });
            }
         }
      }
      # * Nacitani zaznamu ze $zakvzor a zapis do $zakcil
      # nacteni vsech dalsich klicu u $zakvzor
      my $prikeys;
      $sth->execute($zakvzor,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}{$$ref{nar}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         foreach my $nar (sort keys %{$$prikeys{$oper}}) {
            my $info_value=Info->naradi_norma($zakvzor,$oper,$nar);
            # priprava na zapis noveho zaznamu
            my $write={
               _table => $table,
               zak => $zakcil,
               oper => $oper,
               nar => $nar,
               platod => get_env("datum"),
               datzapis => My->datetime_now,
               uzivzapis => My->remote_user
            };
            # dalsi hodnoty preber z hodnot u $zakvzor
            foreach my $col (Write->show_tablecols($table)) {
               if(!defined($$write{$col})) {
                  $$write{$col}=$$info_value{$col};
               }
            }
            my $info_value_future=Info->naradi_norma($zakcil,$oper,$nar,{future=>1});
            # zaznam neexistuje ani v budoucnosti
            if(!($$info_value_future{_exist})) {
               $$write{platdo}="9999-12-31";
            }
            # zaznam existuje v budoucnosti
            else {
               $$write{platdo}=My->date_addday($$info_value_future{platod},-1);
            }
            # zapis noveho zaznamu
            Write->insert($write);
         }
      }
      # oznameni o probehlem kopirovani
      $xhtmlO->aT("p",{style=>"color:green;"},"Norma nad byla zkoprovna.");
   }
   # definice status
   my $status={
      status => $OK,
      hlaska => $xhtmlO
   };
   return $status;
}

#- funkce kopiruje vykonovou normu ze vzorove zakazky na cilovou
sub vykon_norma {
   my ($pkg_p, $zakvzor,$zakcil)=@_;
   # promena pro ukladani hlasky v HTML
   my $docxhtml=XML::LibXML::Document->new;
   my $xhtmlO=MyXML->new("xhtml");
   $docxhtml->setDocumentElement($xhtmlO);
   #=== Kontroly
   my $OK=1;
   my $info_zakcil=Info->zak($zakcil);
   # Cilova zakazka musi mit kmorg shodne s get_env("org")
   if($$info_zakcil{kmorg} ne get_env("org")) {
      $OK=0;
      $xhtmlO->aT("p",{style=>"color:red;"},"Koprovn vkonov normy neme probhnout, jeliko clov zakzka nem jako kmenovou organizaci org " . get_env("org") . ".");
   }
   #=== Kopirovani
   if($OK) {
      my $table="Vyroba_priprava.Vykon_norma";
      my $sth=$dbh->prepare(q{
         select
            Vykon_norma.oper
         from
            Vyroba_priprava.Vykon_norma
         where
            Vykon_norma.zak=? and
            Vykon_norma.platod<=? and
            Vykon_norma.platdo>=?
      });
      # * Uzavreni platnosti vsech existujicich zaznamu v danem case u $zakcil
      # nacteni vsech dalsich klicu u $zakcil
      my $prikeys;
      $sth->execute($zakcil,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         my $info_value=Info->vykon_norma($zakcil,$oper);
         # zaznam plati od zacatku aktualni dekady => "zrus ho"
         if($$info_value{platod} eq get_env("datum")) {
            Write->delete({
               _table => $table,
               _key_zak => $zakcil,
               _key_oper => $oper,
               _key_platod => $$info_value{platod}
            });
         }
         # zaznam plati jiz od drivejska => "uzavri platnost"
         else {
            Write->update({
               _table => $table,
               _key_zak => $zakcil,
               _key_oper => $oper,
               _key_platod => $$info_value{platod},
               platdo => My->date_addday(get_env("datum"),-1),
               _bezdatzapis => 1
            });
         }
      }
      # * Nacitani zaznamu ze $zakvzor a zapis do $zakcil
      # nacteni vsech dalsich klicu u $zakvzor
      my $prikeys;
      $sth->execute($zakvzor,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         my $info_value=Info->vykon_norma($zakvzor,$oper);
         # priprava na zapis noveho zaznamu
         my $write={
            _table => $table,
            zak => $zakcil,
            oper => $oper,
            platod => get_env("datum"),
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         };
         # dalsi hodnoty preber z hodnot u $zakvzor
         foreach my $col (Write->show_tablecols($table)) {
            if(!defined($$write{$col})) {
               $$write{$col}=$$info_value{$col};
            }
         }
         my $info_value_future=Info->vykon_norma($zakcil,$oper,{future=>1});
         # zaznam neexistuje ani v budoucnosti
         if(!($$info_value_future{_exist})) {
            $$write{platdo}="9999-12-31";
         }
         # zaznam existuje v budoucnosti
         else {
            $$write{platdo}=My->date_addday($$info_value_future{platod},-1);
         }
         # zapis noveho zaznamu
         Write->insert($write);
      }
      # oznameni o probehlem kopirovani
      $xhtmlO->aT("p",{style=>"color:green;"},"Vkonov norma byla zkoprovna.");
   }
   # definice status
   my $status={
      status => $OK,
      hlaska => $xhtmlO
   };
   return $status;
}

#- funkce kopiruje popis operace ze vzorove zakazky na cilovou
sub popis_operace {
   my ($pkg_p, $zakvzor,$zakcil)=@_;
   # promena pro ukladani hlasky v HTML
   my $docxhtml=XML::LibXML::Document->new;
   my $xhtmlO=MyXML->new("xhtml");
   $docxhtml->setDocumentElement($xhtmlO);
   #=== Kontroly
   my $OK=1;
   my $info_zakcil=Info->zak($zakcil);
   # Cilova zakazka musi mit kmorg shodne s get_env("org")
   if($$info_zakcil{kmorg} ne get_env("org")) {
      $OK=0;
      $xhtmlO->aT("p",{style=>"color:red;"},"Koprovn popisu operace neme probhnout, jeliko clov zakzka nem jako kmenovou organizaci org " . get_env("org") . ".");
   }
   #=== Kopirovani
   if($OK) {
      my $table="Vyroba_priprava.Popis_operace";
      my $sth=$dbh->prepare(q{
         select
            Popis_operace.oper
         from
            Vyroba_priprava.Popis_operace
         where
            Popis_operace.zak=? and
            Popis_operace.platod<=? and
            Popis_operace.platdo>=?
      });
      # * Uzavreni platnosti vsech existujicich zaznamu v danem case u $zakcil
      # nacteni vsech dalsich klicu u $zakcil
      my $prikeys;
      $sth->execute($zakcil,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         my $info_value=Info->popis_operace($zakcil,$oper);
         # zaznam plati od zacatku aktualni dekady => "zrus ho"
         if($$info_value{platod} eq get_env("datum")) {
            Write->delete({
               _table => $table,
               _key_zak => $zakcil,
               _key_oper => $oper,
               _key_platod => $$info_value{platod}
            });
         }
         # zaznam plati jiz od drivejska => "uzavri platnost"
         else {
            Write->update({
               _table => $table,
               _key_zak => $zakcil,
               _key_oper => $oper,
               _key_platod => $$info_value{platod},
               platdo => My->date_addday(get_env("datum"),-1),
               _bezdatzapis => 1
            });
         }
      }
      # * Nacitani zaznamu ze $zakvzor a zapis do $zakcil
      # nacteni vsech dalsich klicu u $zakvzor
      my $prikeys;
      $sth->execute($zakvzor,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         my $info_value=Info->popis_operace($zakvzor,$oper);
         # priprava na zapis noveho zaznamu
         my $write={
            _table => $table,
            zak => $zakcil,
            oper => $oper,
            platod => get_env("datum"),
            datzapis => My->datetime_now,
            uzivzapis => My->remote_user
         };
         # dalsi hodnoty preber z hodnot u $zakvzor
         foreach my $col (Write->show_tablecols($table)) {
            if(!defined($$write{$col})) {
               $$write{$col}=$$info_value{$col};
               if($col eq "popis") {
                  ## Poznamka: pokud jde o popis operace, tak ten pokud obsahuje
                  ## link na obrazek vztahujici se ke konkretni zakazce a operaci,
                  ## musi byt zmenen, aby odkazoval na cilovou zakazku
                  # prezvykani popisu operace, ktere napriklad zajisti pripadne odstraneni adresy servru v <img src=""> u odkazu na prilohy operace
                  my $docxhtml=XML::LibXML::Document->new;
                  my $xhtmlO=MyXML->new("xhtml");
                  $docxhtml->setDocumentElement($xhtmlO);
                  Output->outputpopis_operace($xhtmlO, { popis => $$write{$col}, _bezplatnost => 1 } );
                  my @matching_tags = $xhtmlO->getElementsByTagName("img");
                  foreach my $match (@matching_tags) { 
                     my $attrs = $match->attributes;
                     foreach my $attr (keys %{$$attrs{NodeMap}}) {
                        if($attr eq "src") {
                           my $value = $$attrs{NodeMap}{$attr}->value;
                           if($value=~/^(\/share\/scripts\/zobprilohyoperace.phtml\?zak=)\Q$zakvzor\E(.*)$/) {
                              $$attrs{NodeMap}{$attr}->setValue($1.$zakcil.$2);
                           }
                        }
                     }
                  }
                  $$write{$col}=$xhtmlO->aNchilds_toStringHTML;
               }
            }
         }
         my $info_value_future=Info->popis_operace($zakcil,$oper,{future=>1});
         # zaznam neexistuje ani v budoucnosti
         if(!($$info_value_future{_exist})) {
            $$write{platdo}="9999-12-31";
         }
         # zaznam existuje v budoucnosti
         else {
            $$write{platdo}=My->date_addday($$info_value_future{platod},-1);
         }
         # zapis noveho zaznamu
         Write->insert($write);
      }
      # oznameni o probehlem kopirovani
      $xhtmlO->aT("p",{style=>"color:green;"},"Popis operace byl zkoprovn.");
   }
   # definice status
   my $status={
      status => $OK,
      hlaska => $xhtmlO
   };
   return $status;
}

#- funkce kopiruje prilohy operace ze vzorove zakazky na cilovou
sub prilohy_operace {
   my ($pkg_p, $zakvzor,$zakcil)=@_;
   # promena pro ukladani hlasky v HTML
   my $docxhtml=XML::LibXML::Document->new;
   my $xhtmlO=MyXML->new("xhtml");
   $docxhtml->setDocumentElement($xhtmlO);
   #=== Kontroly
   my $OK=1;
   my $info_zakcil=Info->zak($zakcil);
   # Cilova zakazka musi mit kmorg shodne s get_env("org")
   if($$info_zakcil{kmorg} ne get_env("org")) {
      $OK=0;
      $xhtmlO->aT("p",{style=>"color:red;"},"Koprovn ploh k operaci neme probhnout, jeliko clov zakzka nem jako kmenovou organizaci org " . get_env("org") . ".");
   }
   #=== Kopirovani
   if($OK) {
      my $table="Vyroba_priprava.Prilohy_operace";
      my $sth=$dbh->prepare(q{
         select
            Prilohy_operace.oper,
            Prilohy_operace.druh,
            Prilohy_operace.ozn
         from
            Vyroba_priprava.Prilohy_operace
         where
            Prilohy_operace.zak=? and
            Prilohy_operace.platod<=? and
            Prilohy_operace.platdo>=?
      });
      # * Uzavreni platnosti vsech existujicich zaznamu v danem case u $zakcil
      # nacteni vsech dalsich klicu u $zakcil
      my $prikeys;
      $sth->execute($zakcil,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}{$$ref{druh}}{$$ref{ozn}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         foreach my $druh (sort keys %{$$prikeys{$oper}}) {
            foreach my $ozn (sort keys %{$$prikeys{$oper}{$druh}}) {
               my $info_value=Info->prilohy_operace($zakcil,$oper,$druh,$ozn);
               # zaznam plati od zacatku aktualni dekady => "zrus ho"
               if($$info_value{platod} eq get_env("datum")) {
                  Write->delete({
                     _table => $table,
                     _key_zak => $zakcil,
                     _key_oper => $oper,
                     _key_druh => $druh,
                     _key_ozn => $ozn,
                     _key_platod => $$info_value{platod}
                  });
               }
               # zaznam plati jiz od drivejska => "uzavri platnost"
               else {
                  Write->update({
                     _table => $table,
                     _key_zak => $zakcil,
                     _key_oper => $oper,
                     _key_druh => $druh,
                     _key_ozn => $ozn,
                     _key_platod => $$info_value{platod},
                     platdo => My->date_addday(get_env("datum"),-1),
                     _bezdatzapis => 1
                  });
               }
            }
         }
      }
      # * Nacitani zaznamu ze $zakvzor a zapis do $zakcil
      # nacteni vsech dalsich klicu u $zakvzor
      my $prikeys;
      $sth->execute($zakvzor,get_env("datum"),get_env("datum"));
      while(my $ref=$sth->fetchrow_hashref) {
         $$prikeys{$$ref{oper}}{$$ref{druh}}{$$ref{ozn}}=1;
      }
      $sth->finish;
      # prochazeni klicemi
      foreach my $oper (sort keys %{$prikeys}) {
         foreach my $druh (sort keys %{$$prikeys{$oper}}) {
            foreach my $ozn (sort keys %{$$prikeys{$oper}{$druh}}) {
               my $info_value=Info->prilohy_operace($zakvzor,$oper,$druh,$ozn);
               # priprava na zapis noveho zaznamu
               my $write={
                  _table => $table,
                  zak => $zakcil,
                  oper => $oper,
                  druh => $druh,
                  ozn => $ozn,
                  platod => get_env("datum"),
                  datzapis => My->datetime_now,
                  uzivzapis => My->remote_user
               };
               # dalsi hodnoty preber z hodnot u $zakvzor
               foreach my $col (Write->show_tablecols($table)) {
                  if(!defined($$write{$col})) {
                     $$write{$col}=$$info_value{$col};
                  }
               }
               my $info_value_future=Info->prilohy_operace($zakcil,$oper,$druh,$ozn,{future=>1});
               # zaznam neexistuje ani v budoucnosti
               if(!($$info_value_future{_exist})) {
                  $$write{platdo}="9999-12-31";
               }
               # zaznam existuje v budoucnosti
               else {
                  $$write{platdo}=My->date_addday($$info_value_future{platod},-1);
               }
               # zapis noveho zaznamu
               Write->insert($write);
            }
         }
      }
      # oznameni o probehlem kopirovani
      $xhtmlO->aT("p",{style=>"color:green;"},"Plohy k operaci byly zkoprovny.");
   }
   # definice status
   my $status={
      status => $OK,
      hlaska => $xhtmlO
   };
   return $status;
}


return 1;

